--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE muxpkg IS

	COMPONENT De2X4
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		Y0: OUT BIT;
		Y1: OUT BIT;
		Y2: OUT BIT;
		Y3: OUT BIT
	);
	END COMPONENT;

	COMPONENT De3X8
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		Y0: OUT BIT;
		Y1: OUT BIT;
		Y2: OUT BIT;
		Y3: OUT BIT;
		Y4: OUT BIT;
		Y5: OUT BIT;
		Y6: OUT BIT;
		Y7: OUT BIT
	);
	END COMPONENT;

	COMPONENT De4X16
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		S3: IN BIT;
		Y0: OUT BIT;
		Y1: OUT BIT;
		Y2: OUT BIT;
		Y3: OUT BIT;
		Y4: OUT BIT;
		Y5: OUT BIT;
		Y6: OUT BIT;
		Y7: OUT BIT;
		Y8: OUT BIT;
		Y9: OUT BIT;
		Y10: OUT BIT;
		Y11: OUT BIT;
		Y12: OUT BIT;
		Y13: OUT BIT;
		Y14: OUT BIT;
		Y15: OUT BIT
	);
	END COMPONENT;

	COMPONENT Mux1of2
	PORT(
		EN: IN BIT;
		S:  IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		Y:  OUT BIT
	);
	END COMPONENT;

	COMPONENT mux2of4 
 	PORT(
 		en : IN bit;
 		s  : IN bit;
 		a1 : IN bit;
 		a0 : IN bit;
 		b1 : IN bit;
 		b0 : IN bit;
 		y1 : OUT bit;
 		y0 : OUT bit
 	);
	END COMPONENT;
 

	COMPONENT Mux1of4
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		D2: IN BIT;
		D3: IN BIT;
		Y:  OUT BIT
	);
	END COMPONENT;


	COMPONENT Mux1of8
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		D2: IN BIT;
		D3: IN BIT;
		D4: IN BIT;
		D5: IN BIT;
		D6: IN BIT;
		D7: IN BIT;
		Y: OUT BIT
	);
	END COMPONENT;

	COMPONENT Mux1of16
	PORT(
		EN: IN BIT;
		S0: IN BIT;
		S1: IN BIT;
		S2: IN BIT;
		S3: IN BIT;
		D0: IN BIT;
		D1: IN BIT;
		D2: IN BIT;
		D3: IN BIT;
		D4: IN BIT;
		D5: IN BIT;
		D6: IN BIT;
		D7: IN BIT;
		D8: IN BIT;
		D9: IN BIT;
		D10: IN BIT;
		D11: IN BIT;
		D12: IN BIT;
		D13: IN BIT;
		D14: IN BIT;
		D15: IN BIT;
		Y: OUT BIT
	);
	END COMPONENT;

END muxpkg;

ENTITY De2X4 is
PORT(
	EN: IN BIT;
	S0: IN BIT;
	S1: IN BIT;
	Y0: OUT BIT;
	Y1: OUT BIT;
	Y2: OUT BIT;
	Y3: OUT BIT
);
END De2X4;

Architecture ARCHde2X4 of de2x4 is
BEGIN
PROCESS BEGIN
    Y0	<= EN and not(S1) and not(S0);
    Y1	<= EN and not(S1) and S0;
    Y2	<= EN and S1 and not(S0);
    Y3	<= EN and S1 and S0;
END PROCESS;
END ARCHde2X4;

ENTITY De3X8 is
PORT(
	EN: IN BIT;
	S0: IN BIT;
	S1: IN BIT;
	S2: IN BIT;
	Y0: OUT BIT;
	Y1: OUT BIT;
	Y2: OUT BIT;
	Y3: OUT BIT;
	Y4: OUT BIT;
	Y5: OUT BIT;
	Y6: OUT BIT;
	Y7: OUT BIT
);
END De3X8;

Architecture ARCHde3X8 of de3x8 is
BEGIN
PROCESS BEGIN
    Y0	<= EN and not(s2) and not(S1) and not(S0);
    Y1	<= EN and not(s2) and not(S1) and S0;
    Y2	<= EN and not(s2) and S1 and not(S0);
    Y3	<= EN and not(s2) and S1 and S0;
    Y4	<= EN and s2 and not(S1) and not(S0);
    Y5	<= EN and s2 and not(S1) and S0;
    Y6	<= EN and s2 and S1 and not(S0);
    Y7	<= EN and s2 and S1 and S0;
END PROCESS;
END ARCHde3x8;


ENTITY De4X16 is
PORT(
	EN: IN BIT;
	S0: IN BIT;
	S1: IN BIT;
	S2: IN BIT;
	S3: IN BIT;
	Y0: OUT BIT;
	Y1: OUT BIT;
	Y2: OUT BIT;
	Y3: OUT BIT;
	Y4: OUT BIT;
	Y5: OUT BIT;
	Y6: OUT BIT;
	Y7: OUT BIT;
	Y8: OUT BIT;
	Y9: OUT BIT;
	Y10: OUT BIT;
	Y11: OUT BIT;
	Y12: OUT BIT;
	Y13: OUT BIT;
	Y14: OUT BIT;
	Y15: OUT BIT
);
END De4X16;

Architecture ARCHde4X16 of de4x16 is
	signal s: bit_vector(0 to 3);
BEGIN
PROCESS BEGIN
    Y0	<= EN and not(s3) and not(s2) and not(S1) and not(S0);
    Y1	<= EN and not(s3) and not(s2) and not(S1) and S0;
    Y2	<= EN and not(s3) and not(s2) and S1 and not(S0);
    Y3	<= EN and not(s3) and not(s2) and S1 and S0;
    Y4	<= EN and not(s3) and s2 and not(S1) and not(S0);
    Y5	<= EN and not(s3) and s2 and not(S1) and S0;
    Y6	<= EN and not(s3) and s2 and S1 and not(S0);
    Y7	<= EN and not(s3) and s2 and S1 and S0;
    Y8	<= EN and s3 and not(s2) and not(S1) and not(S0);
    Y9	<= EN and s3 and not(s2) and not(S1) and S0;
    Y10	<= EN and s3 and not(s2) and S1 and not(S0);
    Y11	<= EN and s3 and not(s2) and S1 and S0;
    Y12	<= EN and s3 and s2 and not(S1) and not(S0);
    Y13	<= EN and s3 and s2 and not(S1) and S0;
    Y14	<= EN and s3 and s2 and S1 and not(S0);
    Y15	<= EN and s3 and s2 and S1 and S0;
END PROCESS;
END ARCHDe4x16;


Entity Mux1of2 is
PORT(
	EN: IN BIT;
	S:  IN BIT;
	D0: IN BIT;
	D1: IN BIT;
	Y:  OUT BIT
);
END Mux1of2;

Architecture ARCHMux1of2 of Mux1of2 is
BEGIN
PROCESS BEGIN
    Y <= EN and (
	    (D0 and not(S))
	OR  (D1 and S)
	);
END PROCESS;
END ARCHMux1of2;

Entity Mux1of4 is
PORT(
	EN: IN BIT;
	S0: IN BIT;
	S1: IN BIT;
	D0: IN BIT;
	D1: IN BIT;
	D2: IN BIT;
	D3: IN BIT;
	Y: OUT BIT
);
END Mux1of4;

Architecture ARCHMux1of4 of Mux1of4 is
BEGIN
PROCESS BEGIN
    Y <= EN AND (
	    (D0 and not(S1) and not(S0))
	OR  (D1 and not(S1) and S0)
	OR  (D2 and S1 and not(S0))
	OR  (D3 and S1 and S0)
	);
END PROCESS;
END ARCHMux1of4;

Entity Mux1of8 is
PORT(
	EN: IN BIT;
	S0: IN BIT;
	S1: IN BIT;
	S2: IN BIT;
	D0: IN BIT;
	D1: IN BIT;
	D2: IN BIT;
	D3: IN BIT;
	D4: IN BIT;
	D5: IN BIT;
	D6: IN BIT;
	D7: IN BIT;
	Y: OUT BIT
);
END Mux1of8;

Architecture ARCHMux1of8 of Mux1of8 is
BEGIN
PROCESS BEGIN
    Y <= EN AND (
	    (D0 and not(s2) and not(S1) and not(S0))
	OR  (D1 and not(s2) and not(S1) and S0)
	OR  (D2 and not(s2) and S1 and not(S0))
	OR  (D3 and not(s2) and S1 and S0)
	OR  (D4 and s2 and not(S1) and not(S0))
	OR  (D5 and s2 and not(S1) and S0)
	OR  (D6 and s2 and S1 and not(S0))
	OR  (D7 and s2 and S1 and S0)
	);
END PROCESS;
END ARCHMux1of8;


Entity Mux1of16 is
PORT(
	EN: IN BIT;
	S0: IN BIT;
	S1: IN BIT;
	S2: IN BIT;
	S3: IN BIT;
	D0: IN BIT;
	D1: IN BIT;
	D2: IN BIT;
	D3: IN BIT;
	D4: IN BIT;
	D5: IN BIT;
	D6: IN BIT;
	D7: IN BIT;
	D8: IN BIT;
	D9: IN BIT;
	D10: IN BIT;
	D11: IN BIT;
	D12: IN BIT;
	D13: IN BIT;
	D14: IN BIT;
	D15: IN BIT;
	Y: OUT BIT
);
END Mux1of16;

Architecture ARCHMux1of16 of Mux1of16 is
	signal s: bit_vector(0 to 3);
BEGIN
PROCESS BEGIN
    Y <= EN AND (
	    (D0 and not(s3) and not(s2) and not(S1) and not(S0))
	OR  (D1 and not(s3) and not(s2) and not(S1) and S0)
	OR  (D2 and not(s3) and not(s2) and S1 and not(S0))
	OR  (D3 and not(s3) and not(s2) and S1 and S0)
	OR  (D4 and not(s3) and s2 and not(S1) and not(S0))
	OR  (D5 and not(s3) and s2 and not(S1) and S0)
	OR  (D6 and not(s3) and s2 and S1 and not(S0))
	OR  (D7 and not(s3) and s2 and S1 and S0)
	OR  (D8 and s3 and not(s2) and not(S1) and not(S0))
	OR  (D9 and s3 and not(s2) and not(S1) and S0)
	OR  (D10 and s3 and not(s2) and S1 and not(S0))
	OR  (D11 and s3 and not(s2) and S1 and S0)
	OR  (D12 and s3 and s2 and not(S1) and not(S0))
	OR  (D13 and s3 and s2 and not(S1) and S0)
	OR  (D14 and s3 and s2 and S1 and not(S0))
	OR  (D15 and s3 and s2 and S1 and S0)
	);
END PROCESS;
END ARCHMux1of16;

entity mux2of4 is
    PORT(en : IN bit;
	s   : IN bit;
	a1  : IN bit;
	a0  : IN bit;
	b1  : IN bit;
	b0  : IN bit;
	y1  : OUT bit;
	y0  : OUT bit);
END mux2of4;

architecture archmux2of4 of mux2of4 is

begin
    y1 <= ((a1 and not s) or (b1 and s)) and en;
    y0 <= ((a0 and not s) or (b0 and s)) and en;

end archmux2of4;
