--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE mathpkg IS
    COMPONENT add
	PORT (CI,
	    A, B: IN BIT;
            SUM, CO: OUT BIT);
    END COMPONENT;

    COMPONENT sub
	PORT (CI,
	    A, B: IN BIT;
            DIF, CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd2
        PORT (CI : IN BIT;
            A1,A0,B1,B0 : IN  BIT; 
            SUM1, SUM0  : OUT BIT;
            CO: OUT BIT);
    END COMPONENT;

    COMPONENT add4
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd4
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub4
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    DIF3,DIF2,DIF1,DIF0 : OUT BIT;
            CO: OUT BIT);
    END COMPONENT;

    COMPONENT add8
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd8
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT nciadd8
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub8
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT add16
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fcadd16
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT nciadd16
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT fbsub16
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8 : OUT BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
    END COMPONENT;

    COMPONENT mult4x4
        PORT (b3,b2,b1,b0,m3,m2,m1,m0 : IN BIT;
              q7,q6,q5,q4,q3,q2,q1,q0 : OUT BIT);
    END COMPONENT;

    COMPONENT COMPBIT2
	PORT (
	    A0,B0,A1,B1 : IN BIT;
	    EQ0, EQ1	: OUT BIT);
    END COMPONENT;

    COMPONENT EQCOMP4
	PORT (
	    A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP8
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

    COMPONENT EQCOMP16
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	    EQ	: OUT	BIT);
    END COMPONENT;

END mathpkg;
--
--	ADD
--

USE WORK.cypress.ALL;

ENTITY add IS
	PORT (CI: IN BIT;
	      A, B: IN BIT;
	      SUM: OUT BIT;
	      CO: OUT BIT);
END add;

ARCHITECTURE archadd OF add IS

BEGIN
	SUM <= (A XOR B) XOR CI;
	CO <= (A AND B) OR ((A AND CI) OR (B AND CI));

END archadd;

--
--	SUBtract
--

USE WORK.cypress.ALL;

ENTITY sub IS
	PORT (CI: IN BIT;
	      A, B: IN BIT;
	      DIF: OUT BIT;
	      CO: OUT BIT);
END sub;

ARCHITECTURE archsub OF sub IS

BEGIN
	DIF <= NOT(NOT(A XOR B) XOR CI);
	CO <= (not A AND B) OR ((not A AND CI) OR (B AND CI));

END archsub;

--
--	Fast Carry ADD 2
--

use work.cypress.all;

entity fcadd2 is
	PORT (CI : IN BIT;
	      A1,A0,B1,B0 : IN  BIT; 
              SUM1, SUM0  : OUT BIT;
              CO: OUT BIT);
end fcadd2;
 
architecture archfcadd2 of fcadd2 is

			signal xp0,xp1,xg1 : bit;
    attribute synthesis_off of xp0,xp1,xg1 : signal is true;

begin
    xp0 <= NOT (NOT A0 AND NOT B0);
    xp1 <= NOT (NOT A1 AND NOT B1);
    xg1 <= NOT (A1 AND B1);

    SUM0 <= NOT (((A0 AND B0) OR ((NOT A0) AND (NOT B0))) XOR CI);
    SUM1 <= (xp1 AND xg1) XOR ((A0 AND B0) OR (CI AND xp0));
    CO  <= ((CI AND xp1 AND xp0) OR (A0 AND B0 AND xp1) OR (A1 AND B1));

end archfcadd2;

--
--	ADD 4
--

use work.cypress.all;
use work.rtlpkg.all;
ENTITY add4 is
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
end add4;

architecture archADD4 of ADD4 is

	signal c1 : bit;
	attribute synthesis_off of  c1 : signal is true;

begin
	add2_0: fcadd2 port map (ci,a1,a0,b1,b0,sum1,sum0,c1);
	add2_1: fcadd2 port map (c1,a3,a2,b3,b2,sum3,sum2,co);

end archADD4;


--
--	Fast Carry ADD 4
--

use work.cypress.all;

entity fcadd4 is
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    SUM3,SUM2,SUM1,SUM0 : OUT BIT;
            CO: OUT BIT);
end fcadd4;
 
architecture archfcadd4 of fcadd4 is

    signal coi : bit;
    signal xp0,xg0,xp1,xg1,xp2,xg2,xp3,xg3 : bit;
    signal xc3,xc4 : bit;
    attribute synthesis_off of coi : signal is true;
    attribute synthesis_off of xp0,xg0,xp1,xg1,xp2,xg2,xp3,xg3 : signal is true;
    attribute synthesis_off of xc3,xc4 : signal is true;

begin
    xp0 <= NOT (NOT A0 AND NOT B0);
    xg0 <= NOT (A0 AND B0);
    xp1 <= NOT (NOT A1 AND NOT B1);
    xg1 <= NOT (A1 AND B1);
    xp2 <= NOT (NOT A2 AND NOT B2);
    xg2 <= NOT (A2 AND B2);
    xp3 <= NOT (NOT A3 AND NOT B3);
    xg3 <= NOT (A3 AND B3);
    xc3 <= (A0 AND B0 AND xp1 AND xp2) OR (A1 AND B1 AND xp2) OR
           (A2 AND B2);
    xc4 <= ((A0 AND B0 AND xp1 AND xp2 AND xp3 AND xg3) OR
           (A1 AND B1 AND xp2 AND xp3 AND xg3) OR
           (A2 AND B2 AND xp3 AND xg3)) XOR (A3 AND B3);
    SUM0 <= (((A0 AND B0) OR (NOT A0 and NOT B0)) XOR NOT CI);
    SUM1 <= (xp1 AND xg1) XOR ((A0 AND B0) OR (CI AND xp0));
    SUM2 <= (xp2 AND xg2) XOR ((A0 AND B0 AND xp1) OR (CI AND xp1 AND xp0)
            OR (A1 AND B1));
    SUM3 <= (xp3 AND xg3) XOR ((CI AND xp2 AND xp1 AND xp0) OR xc3);
    COI  <= ((CI AND xp3 AND xp2 AND xp1 AND xp0) OR xc4);
    CO	 <= COI;

end archfcadd4;

--
--	Fast Borrow SUBtract 4
--

use work.cypress.all;

entity fbsub4 is
	PORT (CI : IN BIT;
	    A3,A2,A1,A0: IN BIT;
	    B3,B2,B1,B0: IN BIT;
	    DIF3,DIF2,DIF1,DIF0 : OUT BIT;
            CO: OUT BIT);
end fbsub4;
 
architecture archfbsub4 of fbsub4 is

    signal coi : bit;
    signal xp0,xg0,xp1,xg1,xp2,xg2,xp3,xg3 : Bit;
    signal xc3,xc4 : Bit;
    attribute synthesis_off of coi : signal is true;
    attribute synthesis_off of xp0,xg0,xp1,xg1,xp2,xg2,xp3,xg3 : signal is true;
    attribute synthesis_off of xc3,xc4 : signal is true;

begin
    xp0 <= NOT (A0 AND NOT B0);
    xg0 <= NOT (NOT A0 AND B0);
    xp1 <= NOT (A1 AND NOT B1);
    xg1 <= NOT (NOT A1 AND B1);
    xp2 <= NOT (A2 AND NOT B2);
    xg2 <= NOT (NOT A2 AND B2);
    xp3 <= NOT (A3 AND NOT B3);
    xg3 <= NOT (NOT A3 AND B3);
    xc3 <= NOT ((NOT A0 AND B0 AND xp1 AND xp2)
	    OR  (NOT A1 AND B1 AND xp2)
	    OR  (NOT A2 AND B2));
    xc4 <= ((NOT A0 AND B0 AND xp1 AND xp2 AND xp3 AND xg3) OR
           (NOT A1 AND B1 AND xp2 AND xp3 AND xg3) OR
           (NOT A2 AND B2 AND xp3 AND xg3)) XOR (NOT A3 AND B3);
    DIF0 <= (((A0 and NOT B0) OR (NOT A0 and B0)) XOR CI);
    DIF1 <= ((xp1 AND xg1) XOR ((xg0 AND NOT CI) OR (xg0 AND NOT xp0)));
    DIF2 <= ((xp2 AND xg2) XOR ((xg0 and xg1 and NOT CI) OR
	    (xg0 and xg1 and NOT xp0) OR (xg1 and NOT xp1)));
    DIF3 <= ((xp3 AND xg3) XOR (NOT(CI AND xp2 AND xp1 AND xp0) AND xc3));

    COI  <= ((CI AND xp3 AND xp2 AND xp1 AND xp0) OR xc4);
    CO   <= COI;

end archfbsub4;

--
--	ADD 8
--

use work.cypress.all;
use work.rtlpkg.all;
ENTITY add8 is
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end add8;

architecture archADD8 of ADD8 is

	signal c1,c2,c3 : bit;
	attribute synthesis_off of  c1,c2,c3 : signal is true;

begin
	add2_0: fcadd2 port map (ci,a1,a0,b1,b0,sum1,sum0,c1);
	add2_1: fcadd2 port map (c1,a3,a2,b3,b2,sum3,sum2,c2);
	add2_2: fcadd2 port map (c2,a5,a4,b5,b4,sum5,sum4,c3);
	add2_3: fcadd2 port map (c3,a7,a6,b7,b6,sum7,sum6,co);

end archADD8;

--
--	Fast Carry ADD 8
--

use work.cypress.all;

entity fcadd8 is
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end fcadd8;
 
architecture archfcadd8 of fcadd8 is

	signal C1 : bit;

begin
	U0:fcadd4 port map(CI,a3,a2,a1,a0,b3,b2,b1,b0,SUM3,SUM2,SUM1,SUM0,C1);
	U1:fcadd4 port map(C1,a7,a6,a5,a4,b7,b6,b5,b4,SUM7,SUM6,SUM5,SUM4,CO);

end archfcadd8;

--
--	No Carry In ADD 8
--

ENTITY nciadd8 is
	PORT (
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end nciadd8;

architecture archNCIADD8 of NCIADD8 is

begin

    U0: fcadd8 port map(zero,
			a7,a6,a5,a4,a3,a2,a1,a0,b7,b6,b5,b4,b3,b2,b1,b0,
			sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,co);

end archNCIADD8;

--
--	Fast Borrow SUBtract 8
--

use work.cypress.all;

entity fbsub8 is
	PORT (CI : IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
end fbsub8;
 
architecture archfbsub8 of fbsub8 is

	signal C1 : bit;

begin
	U0:fbsub4 port map(CI,a3,a2,a1,a0,b3,b2,b1,b0,DIF3,DIF2,DIF1,DIF0,C1);
	U1:fbsub4 port map(C1,a7,a6,a5,a4,b7,b6,b5,b4,DIF7,DIF6,DIF5,DIF4,CO);

end archfbsub8;

--
--	ADD 16
--

use work.cypress.all;
use work.rtlpkg.all;
ENTITY add16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end add16;

architecture archADD16 of ADD16 is

	signal c1,c2,c3,c4,c5,c6,c7 : bit;
	attribute synthesis_off of c1,c2,c3,c4,c5,c6,c7 : signal is true;

begin
	add2_0: fcadd2 port map (ci,a1 ,a0 ,b1 ,b0 ,sum1 ,sum0 ,c1);
	add2_1: fcadd2 port map (c1,a3 ,a2 ,b3 ,b2 ,sum3 ,sum2 ,c2);
	add2_2: fcadd2 port map (c2,a5 ,a4 ,b5 ,b4 ,sum5 ,sum4 ,c3);
	add2_3: fcadd2 port map (c3,a7 ,a6 ,b7 ,b6 ,sum7 ,sum6 ,c4);
	add2_4: fcadd2 port map (c4,a9 ,a8 ,b9 ,b8 ,sum9 ,sum8 ,c5);
	add2_5: fcadd2 port map (c5,a11,a10,b11,b10,sum11,sum10,c6);
	add2_6: fcadd2 port map (c6,a13,a12,b13,b12,sum13,sum12,c7);
	add2_7: fcadd2 port map (c7,a15,a14,b15,b14,sum15,sum14,co);

end archADD16;

--
--	Fast Carry ADD 16
--

ENTITY fcadd16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end fcadd16;

architecture archFCADD16 of FCADD16 is

	signal c1 : bit;
	attribute synthesis_off of c1 : signal is true;

begin
	u0: fcadd8 port map (ci,a7,a6,a5,a4,a3,a2,a1,a0,
				b7,b6,b5,b4,b3,b2,b1,b0,
				sum7,sum6,sum5,sum4,sum3,sum2,sum1,sum0,c1);
	u1: fcadd8 port map (c1,a15,a14,a13,a12,a11,a10,a9,a8,
				b15,b14,b13,b12,b11,b10,b9,b8,
				sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
				co);

end archFCADD16;

--
--	No Carry In ADD 16
--

ENTITY nciadd16 is
	PORT (
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    SUM15,SUM14,SUM13,SUM12,SUM11,SUM10,SUM9,SUM8 : OUT BIT;
	    SUM7,SUM6,SUM5,SUM4,SUM3,SUM2,SUM1,SUM0 : OUT BIT;
	    CO: OUT BIT);
end nciadd16;

architecture archNCIADD16 of NCIADD16 is

begin

    U0: fcadd16 port map(zero,
			a15,a14,a13,a12,a11,a10,a9,a8,a7,a6,a5,a4,a3,a2,a1,a0,
			b15,b14,b13,b12,b11,b10,b9,b8,b7,b6,b5,b4,b3,b2,b1,b0,
			sum15,sum14,sum13,sum12,sum11,sum10,sum9,sum8,
			sum7, sum6, sum5, sum4, sum3, sum2, sum1,sum0,co);

end archNCIADD16;

--
--	Fast Borrow SUBtract 16
--

ENTITY fbsub16 is
	PORT (CI : IN BIT;
	    A15,A14,A13,A12,A11,A10,A9,A8: IN BIT;
	    A7,A6,A5,A4,A3,A2,A1,A0: IN BIT;
	    B15,B14,B13,B12,B11,B10,B9,B8: IN BIT;
	    B7,B6,B5,B4,B3,B2,B1,B0: IN BIT;
	    DIF15,DIF14,DIF13,DIF12,DIF11,DIF10,DIF9,DIF8 : OUT BIT;
	    DIF7,DIF6,DIF5,DIF4,DIF3,DIF2,DIF1,DIF0 : OUT BIT;
	    CO: OUT BIT);
end fbsub16;

architecture archfbsub16 of fbsub16 is

	signal c1 : bit;
	attribute synthesis_off of c1 : signal is true;

begin
	u0: fbsub8 port map (ci,a7,a6,a5,a4,a3,a2,a1,a0,
				b7,b6,b5,b4,b3,b2,b1,b0,
				dif7,dif6,dif5,dif4,dif3,dif2,dif1,dif0,c1);
	u1: fbsub8 port map (c1,a15,a14,a13,a12,a11,a10,a9,a8,
				b15,b14,b13,b12,b11,b10,b9,b8,
				dif15,dif14,dif13,dif12,dif11,dif10,dif9,dif8,
				co);

end archfbsub16;

--
--	MULTiply 4 by 4
--

ENTITY mult4x4 IS
        PORT (b3,b2,b1,b0,m3,m2,m1,m0 : IN BIT;
              q7,q6,q5,q4,q3,q2,q1,q0 : OUT BIT);
END mult4x4;

ARCHITECTURE archMULT4x4 of mult4x4 IS

			signal E1,F1,F2,F3,G1,G2,G3 : bit;
    attribute synthesis_off of E1,F1,F2,F3,G1,G2,G3 : signal is true;

    signal c_1,c_2,c_3,c_4,c_5,c_6,c_7,c_8,c_9,c_a,c_b,c_c : bit;
    attribute synthesis_off of c_1,c_2,c_3,c_4,c_5,c_6 : signal is true;
    attribute synthesis_off of c_7,c_8,c_9,c_a,c_b,c_c : signal is true;
    signal c_d,c_e,c_f,c_g,c_h,c_i,c_j,c_k,c_l : bit;
    attribute synthesis_off of c_d,c_e,c_f,c_g,c_h,c_i : signal is true;
    attribute synthesis_off of c_j,c_k,c_l : signal is true;

    signal c_12,c_13,c_14,c_15,c_23,c_24,c_25,c_26,c_34,c_35,c_36 : bit;
    attribute synthesis_off of c_12,c_13,c_14,c_15 : signal is true;
    attribute synthesis_off of c_23,c_24,c_25,c_26 : signal is true;
    attribute synthesis_off of c_34,c_35,c_36 : signal is true;

    signal s_13,s_14,s_15,s_24,s_25,s_26 : bit;
    attribute synthesis_off of  s_13,s_14,s_15,s_24,s_25,s_26 : signal is true;

    signal q7i,q6i,q5i,q4i,q3i,q2i,q1i,q0i : bit;
    attribute synthesis_off of q7i,q6i,q5i,q4i,q3i,q2i,q1i,q0i : signal is true;

BEGIN

	E1 <= NOT (m1 and b1);

	F1 <= NOT (m2 and b1);
	F2 <= NOT (m2 and b2);
	F3 <= NOT (m2 and b3);

	G1 <= NOT (m3 and b1);
	G2 <= NOT (m3 and b2);
	G3 <= NOT (m3 and b3);

	c_12 <= NOT (m0 and b1 and m1 and b0);
	c_1  <= NOT (m0 and b2 and m1 and b1);
	c_2  <= NOT (m0 and b2 and m0 and b1 and m1 and b0);
	c_3  <= NOT (m1 and b1 and m0 and b1 and m1 and b0);
	c_13 <= NOT (c_1 and c_2 and c_3);
	c_4  <= NOT (m0 and b3 and m1 and b2);
	c_5  <= NOT (m0 and b3 and c_13);
	c_6  <= NOT (m1 and b2 and c_13);
	c_14 <= NOT (c_4 and c_5 and c_6);
	c_15 <= NOT (m1 and b3 and c_14);

	s_13 <= ((m0 and b2) xor
	    ((m1 and b1 AND c_12) OR
	    (E1 AND m0 and b1 and m1 and b0)));
	s_14 <= ((m0 and b3) xor
	    ((m1 and b2 AND c_1 and c_2 and c_3) OR
	    (NOT m1 AND c_13) OR
	    (NOT b2 AND c_13)));
	s_15 <= ((m1 and b3) xor c_14);

	c_23 <= NOT (m2 and b0 and s_13);
	c_7  <= NOT (s_14 and m2 and b1);
	c_8  <= NOT (s_14 and m2 and b0 and s_13);
	c_9  <= NOT (m2 and b1 and m2 and b0 and s_13);
	c_24 <= NOT (c_7 and c_8 and c_9);
	c_a  <= NOT (s_15 and m2 and b2);
	c_b  <= NOT (s_15 and c_24);
	c_c  <= NOT (m2 and b2 and c_24);
	c_25 <= NOT (c_a and c_b and c_c);
	c_d  <= NOT (m1 and b3 and c_14 and m2 and b3);
	c_e  <= NOT (m1 and b3 and c_14 and c_25);
	c_f  <= NOT (m2 and b3 and c_25);
	c_26 <= NOT (c_d and c_e and c_f);

	s_24 <=((m2 and b0 and s_13) xor
		((s_14 AND F1) OR
		(NOT s_14 AND m2 and b1)));
	s_25 <=(c_24 xor
		((s_15 AND F2) OR
		(NOT s_15 AND m2 and b2)));
	s_26 <=(c_25 xor
		((m1 and b3 and c_14 AND F3) OR
		(c_15 AND m2 and b3)));

	c_34 <= NOT (m3 and b0 and s_24);
	c_g  <= NOT (s_25 and m3 and b1);
	c_h  <= NOT (s_25 and m3 and b0 and s_24);
	c_i  <= NOT (m3 and b1 and m3 and b0 and s_24);
	c_35 <= NOT (c_g and c_h and c_i);
	c_j  <= NOT (s_26 and m3 and b2);
	c_k  <= NOT (s_26 and c_35);
	c_l  <= NOT (m3 and b2 and c_35);
	c_36 <= NOT (c_j and c_k and c_l);

	q0i <=(m0 and b0);
	q1i <=((m0 and b1) xor (m1 and b0));
	q2i <=(s_13 xor (m2 and b0));
	q3i <=(s_24 xor (m3 and b0));
	q4i <=((m3 and b0 and s_24) xor
		((s_25 and G1) OR
		(NOT s_25 and m3 and b1)));
	q5i <=(c_35 xor
		((s_26 and G2) OR
		(NOT s_26 and m3 and b2)));
	q6i <=(c_36 xor
		((c_26 and G3) OR
		(c_d and c_e and c_f and m3 and b3)));
	q7i <=((c_26 and m3 and b3) or (c_26 and c_36) or (m3 and b3 and c_36));

	q0 <= q0i;
	q1 <= q1i;
	q2 <= q2i;
	q3 <= q3i;
	q4 <= q4i;
	q5 <= q5i;
	q6 <= q6i;
	q7 <= q7i;
	
END archMULT4x4;

--
--	COMPare 2 BITs
--

use work.cypress.all;
use work.rtlpkg.all;

entity COMPBIT2 is
    PORT (
	A0,B0,A1,B1 : IN BIT;
	EQ0, EQ1 : OUT BIT);
end COMPBIT2;

architecture archCOMPBIT2 of COMPBIT2 is
begin

	eq0 <= (NOT(a1 xor b1) AND a0 AND NOT b0) OR (NOT a0 AND b0);
	eq1 <= (NOT(a1 xor b1));

end archCOMPBIT2;

--
--	EQual COMPare 4
--

use work.cypress.all;
use work.rtlpkg.all;

entity EQCOMP4 is
    PORT (
	A3,A2,A1,A0,B3,B2,B1,B0 : IN BIT;
	EQ : OUT BIT);
end EQCOMP4;

architecture archEQCOMP4 of EQCOMP4 is

	signal x3,x2,x1,x0 : bit;
	attribute synthesis_off of x3,x2,x1,x0 : signal is true;
	signal y3,y2,y1,y0: bit;
	attribute synthesis_off of y3,y2,y1,y0 : signal is true;

begin
	x3 <= NOT(a3 AND NOT b3);
	y3 <= NOT(b3 AND NOT a3);
	x2 <= NOT(a2 AND NOT b2);
	y2 <= NOT(b2 AND NOT a2);
	x1 <= NOT(a1 AND NOT b1);
	y1 <= NOT(b1 AND NOT a1);
	x0 <= NOT(a0 AND NOT b0);
	y0 <= NOT(b0 AND NOT a0);

	eq <= (x3 and y3 and x2 and y2 and x1 and y1 and x0 and y0);

end archEQCOMP4;

--
--	EQual COMPare 8
--

use work.cypress.all;
use work.rtlpkg.all;

entity EQCOMP8 is
    PORT (
	A7,A6,A5,A4,A3,A2,A1,A0,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	EQ : OUT BIT);
end EQCOMP8;

architecture archEQCOMP8 of EQCOMP8 is

	signal x7,x6,x5,x4,x3,x2,x1,x0 : bit;
	attribute synthesis_off of x7,x6,x5,x4,x3,x2,x1,x0 : signal is true;
	signal y7,y6,y5,y4,y3,y2,y1,y0: bit;
	attribute synthesis_off of y7,y6,y5,y4,y3,y2,y1,y0 : signal is true;

begin
	x7 <= NOT(a7 AND NOT b7);
	y7 <= NOT(b7 AND NOT a7);
	x6 <= NOT(a6 AND NOT b6);
	y6 <= NOT(b6 AND NOT a6);
	x5 <= NOT(a5 AND NOT b5);
	y5 <= NOT(b5 AND NOT a5);
	x4 <= NOT(a4 AND NOT b4);
	y4 <= NOT(b4 AND NOT a4);
	x3 <= NOT(a3 AND NOT b3);
	y3 <= NOT(b3 AND NOT a3);
	x2 <= NOT(a2 AND NOT b2);
	y2 <= NOT(b2 AND NOT a2);
	x1 <= NOT(a1 AND NOT b1);
	y1 <= NOT(b1 AND NOT a1);
	x0 <= NOT(a0 AND NOT b0);
	y0 <= NOT(b0 AND NOT a0);

	eq <= x7 and y7 and x6 and y6 and x5 and y5 and x4 and y4
	  and x3 and y3 and x2 and y2 and x1 and y1 and x0 and y0;

end archEQCOMP8;

--
--	EQual COMPare 16
--

use work.cypress.all;
use work.rtlpkg.all;

entity EQCOMP16 is
    PORT (
	A15,A14,A13,A12,A11,A10,A9,A8,A7,A6,A5,A4,A3,A2,A1,A0 : IN BIT;
	B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0 : IN BIT;
	EQ : OUT BIT);
end EQCOMP16;

architecture archEQCOMP16 of EQCOMP16 is

	signal x7,x6,x5,x4,x3,x2,x1,x0 : bit;
	attribute synthesis_off of x7,x6,x5,x4,x3,x2,x1,x0 : signal is true;
	signal x8,x9,xa,xb,xc,xd,xe,xf : bit;
	attribute synthesis_off of x8,x9,xa,xb,xc,xd,xe,xf : signal is true;
	signal y7,y6,y5,y4,y3,y2,y1,y0: bit;
	attribute synthesis_off of y7,y6,y5,y4,y3,y2,y1,y0 : signal is true;
	signal y8,y9,ya,yb,yc,yd,ye,yf : bit;
	attribute synthesis_off of y8,y9,ya,yb,yc,yd,ye,yf : signal is true;

begin
	xf <= NOT(a15 AND NOT b15);
	yf <= NOT(b15 AND NOT a15);
	xe <= NOT(a14 AND NOT b14);
	ye <= NOT(b14 AND NOT a14);
	xd <= NOT(a13 AND NOT b13);
	yd <= NOT(b13 AND NOT a13);
	xc <= NOT(a12 AND NOT b12);
	yc <= NOT(b12 AND NOT a12);
	xb <= NOT(a11 AND NOT b11);
	yb <= NOT(b11 AND NOT a11);
	xa <= NOT(a10 AND NOT b10);
	ya <= NOT(b10 AND NOT a10);
	x9 <= NOT(a9 AND NOT b9);
	y9 <= NOT(b9 AND NOT a9);
	x8 <= NOT(a8 AND NOT b8);
	y8 <= NOT(b8 AND NOT a8);
	x7 <= NOT(a7 AND NOT b7);
	y7 <= NOT(b7 AND NOT a7);
	x6 <= NOT(a6 AND NOT b6);
	y6 <= NOT(b6 AND NOT a6);
	x5 <= NOT(a5 AND NOT b5);
	y5 <= NOT(b5 AND NOT a5);
	x4 <= NOT(a4 AND NOT b4);
	y4 <= NOT(b4 AND NOT a4);
	x3 <= NOT(a3 AND NOT b3);
	y3 <= NOT(b3 AND NOT a3);
	x2 <= NOT(a2 AND NOT b2);
	y2 <= NOT(b2 AND NOT a2);
	x1 <= NOT(a1 AND NOT b1);
	y1 <= NOT(b1 AND NOT a1);
	x0 <= NOT(a0 AND NOT b0);
	y0 <= NOT(b0 AND NOT a0);

	eq <= xf and yf and xe and ye and xd and yd and xc and yc
	  and xb and yb and xa and ya and x9 and y9 and x8 and y8
	  and x7 and y7 and x6 and y6 and x5 and y5 and x4 and y4
	  and x3 and y3 and x2 and y2 and x1 and y1 and x0 and y0;

end archEQCOMP16;
