--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

USE WORK.cypress.ALL;
USE WORK.rtlpkg.all;

PACKAGE memorypkg IS

    COMPONENT dsrlch 
	PORT (
	    D	: IN BIT;
	    S	: IN BIT;
	    R	: IN BIT;
	    E	: IN BIT;
	    Q	: OUT BIT);
    END COMPONENT;
    attribute atomic_rtl of dsrlch : component is dsrlch_type;

    COMPONENT xdsrff 
    PORT (
	  X1 : IN BIT;
	  X2 : IN BIT;
	  S : IN BIT;
	  R : IN BIT;
	  CLK : IN BIT;
	  Q : OUT BIT);
    END COMPONENT;

    COMPONENT tsrff 
    PORT (
	  T : IN BIT;
	  S : IN BIT;
	  R : IN BIT;
	  CLK : IN BIT;
	  Q : OUT BIT);
    END COMPONENT;
    attribute atomic_rtl of tsrff : component is tsrff_type;

    COMPONENT jksrff 
    PORT (
	  J : IN BIT;
	  K : IN BIT;
	  S : IN BIT;
	  R : IN BIT;
	  CLK : IN BIT;
	  Q : OUT BIT);
    END COMPONENT;

END memorypkg;

-----------

ENTITY xdsrff IS
	PORT (
	      X1 : IN BIT;
	      X2 : IN BIT;
	      S : IN BIT;
	      R : IN BIT;
	      CLK : IN BIT;
	      Q : OUT BIT
	);
END xdsrff;

USE WORK.rtlpkg.all;

ARCHITECTURE archXDSRFF of xdsrff IS
	signal dtmp:bit;
BEGIN
	dtmp <= x1 xor x2;
	x:dsrff port map(dtmp,s,r,clk,q);

END archXDSRFF;

-----------

ENTITY jksrff IS
	PORT (
	      J : IN BIT;
	      K : IN BIT;
	      S : IN BIT;
	      R : IN BIT;
	      CLK : IN BIT;
	      Q : OUT BIT
	);
END jksrff;

USE WORK.rtlpkg.all;

ARCHITECTURE archJKSRFF of jksrff IS
	signal tmp,qtmp:bit;
BEGIN
	tmp <= ((J AND NOT qtmp) OR (NOT K AND QTMP));
	x:dsrff port map(tmp,s,r,clk,qtmp);
	q <= qtmp;

END archJKSRFF;
