--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

PACKAGE gatespkg IS
    COMPONENT AND2
	PORT ( 
	    a,b		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT AND3
	PORT (
	    a,b,c	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT AND4
	PORT (
	    a,b,c,d 	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT AND8
	PORT (
	    a,b,c,d,e,f,g,h	: IN BIT;
	    q			: OUT BIT);
    END COMPONENT;

    COMPONENT NAND2
	PORT ( 
	    a,b		: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT NAND3
	PORT ( 
	    a,b,c	: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT NAND4
	PORT ( 
	    a,b,c,d	: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT NAND8
	PORT ( 
	    a,b,c,d,e,f,g,h	: IN BIT;
	    qn			: OUT BIT);
    END COMPONENT;

    COMPONENT OR2
	PORT ( 
	    a,b		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT OR3
	PORT ( 
	    a,b,c	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT OR4
	PORT ( 
	    a,b,c,d	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT OR8
	PORT ( 
	    a,b,c,d,e,f,g,h	: IN BIT;
	    q			: OUT BIT);
    END COMPONENT;

    COMPONENT NOR2
	PORT ( 
	    a,b		: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT NOR3
	PORT ( 
	    a,b,c	: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT NOR4
	PORT ( 
	    a,b,c,d	: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT NOR8
	PORT ( 
	    a,b,c,d,e,f,g,h	: IN BIT;
	    qn			: OUT BIT);
    END COMPONENT;

    COMPONENT XOR2
	PORT ( 
	    a,b		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT XOR3
	PORT ( 
	    a,b,c	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT XOR4
	PORT ( 
	    a,b,c,d	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT XOR8
	PORT ( 
	    a,b,c,d,e,f,g,h	: IN BIT;
	    q			: OUT BIT);
    END COMPONENT;

    COMPONENT XNOR2
	PORT ( 
	    a,b		: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT XNOR3
	PORT ( 
	    a,b,c	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT XNOR4
	PORT ( 
	    a,b,c,d	: IN BIT;
	    q		: OUT BIT);
    END COMPONENT;

    COMPONENT XNOR8
	PORT ( 
	    a,b,c,d,e,f,g,h	: IN BIT;
	    q			: OUT BIT);
    END COMPONENT;

    COMPONENT BUF
	PORT (
	    x		: IN BIT;
	    y		: OUT BIT);
    END COMPONENT;

    COMPONENT INV
	PORT (
	    a		: IN BIT;
	    qn		: OUT BIT);
    END COMPONENT;

    COMPONENT AND14I7
	PORT (
	    a,b,c,d,e,f,g,h,i,j,k,l,m,n	: IN BIT;
	    q				: OUT BIT);
    END COMPONENT;

    COMPONENT NAND13I6
	PORT (
	    a,b,c,d,e,f,g,h,i,j,k,l,m	: IN BIT;
	    qn				: OUT BIT);
    END COMPONENT;

    COMPONENT OR13I6
	PORT (
	    a,b,c,d,e,f,g,h,i,j,k,l,m	: IN BIT;
	    q				: OUT BIT);
    END COMPONENT;

    COMPONENT NOR14I7
	PORT (
	    a,b,c,d,e,f,g,h,i,j,k,l,m,n	: IN BIT;
	    qn				: OUT BIT);
    END COMPONENT;

    COMPONENT SOP14I7
	PORT (
	    a,b,c,d,e,f,g,h,i,j,k,l,m,n	: IN BIT;
	    q				: OUT BIT);
    END COMPONENT;

END gatespkg;

package gates_local is
    COMPONENT logico		-- Master Logic Cell.
	PORT (
	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    oz	: OUT bit	-- Output of MUX O.
	);
    END COMPONENT;
end gates_local ;
------

USE WORK.cypress.ALL;
ENTITY AND2 IS
    PORT ( 
	a,b	: IN BIT;
	q	: OUT BIT);
END AND2;

ARCHITECTURE archAND2 OF AND2 IS
BEGIN
    q <= (a AND b);
END archAND2;

------

USE WORK.cypress.ALL;
ENTITY AND3 IS
    PORT (
	a,b,c	: IN BIT;
	q	: OUT BIT);
END AND3;

ARCHITECTURE archAND3 OF AND3 IS
BEGIN
    q <= (a AND b AND c);
END archAND3;

------

USE WORK.cypress.ALL;
ENTITY AND4 IS
    PORT (
	a,b,c,d : IN BIT;
	q	: OUT BIT);
END AND4;

ARCHITECTURE archAND4 OF AND4 IS
BEGIN
    q <= (a AND b AND c AND d);
END archAND4;

------

USE WORK.cypress.ALL;
ENTITY AND8 IS
    PORT (
	a,b,c,d,e,f,g,h	: IN BIT;
	q		: OUT BIT);
END AND8;

ARCHITECTURE archAND8 OF AND8 IS
BEGIN
    q <= (a AND b AND c AND d AND e AND f AND g AND h);
END archAND8;

------

USE WORK.cypress.ALL;
ENTITY NAND2 IS
    PORT ( 
	a,b	: IN BIT;
	qn	: OUT BIT);
END NAND2;

ARCHITECTURE archNAND2 OF NAND2 IS
BEGIN
    qn <= (a NAND b);
END archNAND2;

------

USE WORK.cypress.ALL;
ENTITY NAND3 IS
    PORT ( 
	a,b,c	: IN BIT;
	qn	: OUT BIT);
END NAND3;

ARCHITECTURE archNAND3 OF NAND3 IS
BEGIN
    qn <= NOT (a AND b AND c);
END archNAND3;

------

USE WORK.cypress.ALL;
ENTITY NAND4 IS
    PORT ( 
	a,b,c,d	: IN BIT;
	qn	: OUT BIT);
END NAND4;

ARCHITECTURE archNAND4 OF NAND4 IS
BEGIN
    qn <= NOT (a AND b AND c AND d);
END archNAND4;

------

USE WORK.cypress.ALL;
ENTITY NAND8 IS
    PORT ( 
	a,b,c,d,e,f,g,h	: IN BIT;
	qn		: OUT BIT);
END NAND8;

ARCHITECTURE archNAND8 OF NAND8 IS
BEGIN
    qn <= NOT (a AND b AND c AND d AND e AND f AND g AND h);
END archnAND8;

------

USE WORK.cypress.ALL;
ENTITY OR2 IS
    PORT ( 
	a,b	: IN BIT;
	q	: OUT BIT);
END OR2;

ARCHITECTURE archOR2 OF OR2 IS
BEGIN
    q <= (a OR b);
END archOR2;

------

USE WORK.cypress.ALL;
ENTITY OR3 IS
    PORT ( 
	a,b,c	: IN BIT;
	q	: OUT BIT);
END OR3;

ARCHITECTURE archOR3 OF OR3 IS
BEGIN
    q <= (a OR b OR c);
END archOR3;

------

USE WORK.cypress.ALL;
ENTITY OR4 IS
    PORT ( 
	a,b,c,d	: IN BIT;
	q	: OUT BIT);
END OR4;

ARCHITECTURE archOR4 OF OR4 IS
BEGIN
    q <= (a OR b OR c OR d);
END archOR4;

------

USE WORK.cypress.ALL;
ENTITY OR8 IS
    PORT ( 
	a,b,c,d,e,f,g,h	: IN BIT;
	q		: OUT BIT);
END OR8;

ARCHITECTURE archOR8 OF OR8 IS
BEGIN
    q <= (a OR b OR c OR d OR e OR f OR g OR h);
END archOR8;

------

USE WORK.cypress.ALL;
ENTITY NOR2 IS
    PORT ( 
	a,b	: IN BIT;
	qn	: OUT BIT);
END NOR2;

ARCHITECTURE archNOR2 OF NOR2 IS
BEGIN
    qn <= (a NOR b);
END archNOR2;

------

USE WORK.cypress.ALL;
ENTITY NOR3 IS
    PORT ( 
	a,b,c	: IN BIT;
	qn	: OUT BIT);
END NOR3;

ARCHITECTURE archNOR3 OF NOR3 IS
BEGIN
    qn <= NOT (a OR b OR c);
END archNOR3;

------

USE WORK.cypress.ALL;
ENTITY NOR4 IS
    PORT ( 
	a,b,c,d	: IN BIT;
	qn	: OUT BIT);
END NOR4;

ARCHITECTURE archNOR4 OF NOR4 IS
BEGIN
    qn <= NOT (a OR b OR c OR d);
END archNOR4;

------

USE WORK.cypress.ALL;
ENTITY NOR8 IS
    PORT ( 
	a,b,c,d,e,f,g,h	: IN BIT;
	qn		: OUT BIT);
END NOR8;

ARCHITECTURE archNOR8 OF NOR8 IS
BEGIN
    qn <= NOT (a OR b OR c OR d OR e OR f OR g OR h);
END archNOR8;

------

USE WORK.cypress.ALL;
ENTITY XOR3 IS
    PORT ( 
	a,b,c	: IN BIT;
	q	: OUT BIT);
END XOR3;

ARCHITECTURE archXOR3 OF XOR3 IS
BEGIN
    q <= (a XOR b XOR c);
END archXOR3;

------

USE WORK.cypress.ALL;
ENTITY XOR4 IS
    PORT ( 
	a,b,c,d	: IN BIT;
	q	: OUT BIT);
END XOR4;

ARCHITECTURE archXOR4 OF XOR4 IS
BEGIN
    q <= (a XOR b XOR c XOR d);
END archXOR4;

------

USE WORK.cypress.ALL;
ENTITY XOR8 IS
    PORT ( 
	a,b,c,d,e,f,g,h	: IN BIT;
	q		: OUT BIT);
END XOR8;

ARCHITECTURE archXOR8 OF XOR8 IS
BEGIN
    q <= (a XOR b XOR c XOR d XOR e XOR f XOR g XOR h);
END archXOR8;

------

USE WORK.cypress.ALL;
ENTITY XNOR2 IS
    PORT ( 
	a,b	: IN BIT;
	q	: OUT BIT);
END XNOR2;

ARCHITECTURE archXNOR2 OF XNOR2 IS
BEGIN
    q <= NOT (a XOR b);
END archXNOR2;

------

USE WORK.cypress.ALL;
ENTITY XNOR3 IS
    PORT ( 
	a,b,c	: IN BIT;
	q	: OUT BIT);
END XNOR3;

ARCHITECTURE archXNOR3 OF XNOR3 IS
BEGIN
    q <= NOT (a XOR b XOR c);
END archXNOR3;

------

USE WORK.cypress.ALL;
ENTITY XNOR4 IS
    PORT ( 
	a,b,c,d	: IN BIT;
	q	: OUT BIT);
END XNOR4;

ARCHITECTURE archXNOR4 OF XNOR4 IS
BEGIN
    q <= NOT (a XOR b XOR c XOR d);
END archXNOR4;

------

USE WORK.cypress.ALL;
ENTITY XNOR8 IS
    PORT ( 
	a,b,c,d,e,f,g,h	: IN BIT;
	q		: OUT BIT);
END XNOR8;

ARCHITECTURE archXNOR8 OF XNOR8 IS
BEGIN
    q <= NOT (a XOR b XOR c XOR d XOR e XOR f XOR g XOR h);
END archXNOR8;

------

USE WORK.cypress.ALL;
ENTITY INV IS
    PORT (
	a	: IN BIT;
	qn	: OUT BIT);
END INV;

ARCHITECTURE archINV OF INV IS
BEGIN
    qn <= NOT (a);
END archINV;

------

USE WORK.cypress.ALL;
USE WORK.gates_local.ALL;
ENTITY AND14I7 IS
    PORT (
	a,b,c,d,e,f,g,h,i,j,k,l,m,n	: IN BIT;
	q				: OUT BIT);
    attribute dont_touch of and14i7 : entity is true;
END AND14I7;

ARCHITECTURE archAND14I7 OF AND14I7 IS

BEGIN

    U1:logico port map (a,h,b,i,c,j,
			zero,one,zero,one,zero,one,d,k,
			e,l,f,m,g,n,q);

END archAND14I7;

------

USE WORK.cypress.ALL;
USE WORK.gates_local.ALL;
ENTITY NAND13I6 IS
    PORT (
	a,b,c,d,e,f,g,h,i,j,k,l,m	: IN BIT;
	qn				: OUT BIT);
END NAND13I6;

ARCHITECTURE archNAND13I6 OF NAND13I6 IS

BEGIN

    U1:logico port map (a,h,b,i,c,j,
			one,zero,one,zero,one,zero,one,d,
			e,k,f,l,g,m,qn);

END archNAND13I6;

------

USE WORK.cypress.ALL;
USE WORK.gates_local.ALL;
ENTITY OR13I6 IS
    PORT (
	a,b,c,d,e,f,g,h,i,j,k,l,m	: IN BIT;
	q				: OUT BIT);
END OR13I6;

ARCHITECTURE archOR13I6 OF OR13I6 IS

BEGIN

    U1:logico port map (h,a,i,b,j,c,
			one,zero,one,zero,one,zero,d,zero,
			k,e,l,f,m,g,q);

END archOR13I6;

------

USE WORK.cypress.ALL;
USE WORK.gates_local.ALL;
ENTITY NOR14I7 IS
    PORT (
	a,b,c,d,e,f,g,h,i,j,k,l,m,n	: IN BIT;
	qn				: OUT BIT);
    attribute dont_touch of nor14i7 : entity is true;
END NOR14I7;

ARCHITECTURE archNOR14I7 OF NOR14I7 IS

BEGIN

    U1:logico port map (h,a,i,b,j,c,
			zero,one,zero,one,zero,one,k,d,
			l,e,m,f,n,g,qn);

END archNOR14I7;

------

USE WORK.cypress.ALL;
USE WORK.gates_local.ALL;
ENTITY SOP14I7 IS
    PORT (
	a,b,c,d,e,f,g,h,i,j,k,l,m,n	: IN BIT;
	q				: OUT BIT);
    attribute dont_touch of sop14i7 : entity is true;
END SOP14I7;

ARCHITECTURE archSOP14I7 OF SOP14I7 IS

BEGIN

    U1:logico port map (a,d,b,e,c,f,
			g,h,one,zero,one,zero,one,zero,
			i,l,j,m,k,n,q);

END archSOP14I7;
