--
--      Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--        as an unpublished work.
--

PACKAGE muxpkg IS 
COMPONENT de2x4
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		y0 : OUT bit;
		y1 : OUT bit;
		y2 : OUT bit;
		y3 : OUT bit
	);
END COMPONENT;

COMPONENT de3x8 
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		s2 : IN bit;
		y0 : OUT bit;
		y1 : OUT bit;
		y2 : OUT bit;
		y3 : OUT bit;
		y4 : OUT bit;
		y5 : OUT bit;
		y6 : OUT bit;
		y7 : OUT bit
	);
END COMPONENT;

COMPONENT de4x16 
	PORT(
		 en : IN bit;
		 s0 : IN bit;
		 s1 : IN bit;
		 s2 : IN bit;
		 s3 : IN bit;
		 y0 : OUT bit;
		 y1 : OUT bit;
		 y2 : OUT bit;
		 y3 : OUT bit;
		 y4 : OUT bit;
		 y5 : OUT bit;
		 y6 : OUT bit;
		 y7 : OUT bit;
		 y8 : OUT bit;
		 y9 : OUT bit;
		 y10 : OUT bit;
		 y11 : OUT bit;
		 y12 : OUT bit;
		 y13 : OUT bit;
		 y14 : OUT bit;
		 y15 : OUT bit

	);
END COMPONENT;

COMPONENT mux1of2 
	PORT(
		en : IN bit;
		s : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		y : OUT bit
	);
END COMPONENT;

COMPONENT mux1of4 
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		d2 : IN bit;
		d3 : IN bit;
		y : OUT bit
	);
END COMPONENT;

COMPONENT mux2of4 
	PORT(
		en : IN bit;
		s  : IN bit;
		a1 : IN bit;
		a0 : IN bit;
		b1 : IN bit;
		b0 : IN bit;
		y1 : OUT bit;
		y0 : OUT bit
	);
END COMPONENT;

COMPONENT mux1of8 
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		s2 : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		d2 : IN bit;
		d3 : IN bit;
		d4 : IN bit;
		d5 : IN bit;
		d6 : IN bit;
		d7 : IN bit;
		y : OUT bit
	);
END COMPONENT;

COMPONENT mux1of16 
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		s2 : IN bit;
		s3 : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		d2 : IN bit;
		d3 : IN bit;
		d4 : IN bit;
		d5 : IN bit;
		d6 : IN bit;
		d7 : IN bit;
		d8 : IN bit;
		d9 : IN bit;
		d10 : IN bit;
		d11 : IN bit;
		d12 : IN bit;
		d13 : IN bit;
		d14 : IN bit;
		d15 : IN bit;
		y : OUT bit
	);
END COMPONENT;

END muxpkg;

package mux_local is
    COMPONENT PAfrag_a
	PORT (
	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    az	: OUT bit	-- Output of AND A.
	);
    END COMPONENT;
    COMPONENT PAfrag_m		-- Fragment M.
	PORT (
	    os	: IN bit;	-- Select to MUX O.
	    nsi	: IN bit;	-- Select to MUX N.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    oz	: OUT bit;	-- Output of MUX O.
	    nz	: OUT bit	-- Output of MUX N.
	);
    END COMPONENT;
    COMPONENT PAfrag_f		-- Fragment AND F.
	PORT (
	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    fz	: OUT bit	-- Output of AND F.
	);
    END COMPONENT;
    COMPONENT logico		-- Master Logic Cell.
	PORT (
	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    oz	: OUT bit	-- Output of MUX O.
	);
    END COMPONENT;
end mux_local ;

USE work.cypress.all;
USE work.mux_local.all;
ENTITY de2x4  IS
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		y0 : OUT bit;
		y1 : OUT bit;
		y2 : OUT bit;
		y3 : OUT bit
	);
END de2x4 ;

ARCHITECTURE archde2x4 OF de2x4 IS
attribute dont_touch of f1, f2 : label is true;
attribute dont_touch of f3, f4 : label is true;

BEGIN

f1:pafrag_a PORT MAP(en,zero,one,s0,one,s1,y0) ;
f2:pafrag_f PORT MAP(en,zero,s0,zero,one,s1,y1);

f3:pafrag_a PORT MAP(en,zero,s1,zero,one,s0,y2) ;
f4:pafrag_f PORT MAP(en,zero,s0,zero,s1,zero,y3) ;

END archde2x4;
--------------------------------------------------------
USE work.cypress.all;
USE work.mux_local.all;
ENTITY de3x8  IS
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		s2 : IN bit;
		y0 : OUT bit;
		y1 : OUT bit;
		y2 : OUT bit;
		y3 : OUT bit;
		y4 : OUT bit;
		y5 : OUT bit;
		y6 : OUT bit;
		y7 : OUT bit
	);
END de3x8 ;

ARCHITECTURE archde3x8 OF de3x8  IS

attribute dont_touch of f1, f2 : label is true;
attribute dont_touch of f3, f4 : label is true;
attribute dont_touch of f5, f6 : label is true;

BEGIN

    f1:pafrag_a PORT MAP(en,s2,one,s0,one,s1,y0);
    f2:pafrag_f PORT MAP(en,zero,s0,s2,one,s1,y1);

    f3:pafrag_a PORT MAP(en,zero,s1,s2,one,s0,y2);
    f4:pafrag_f PORT MAP(en,zero,s0,zero,s1,s2,y3);

    f5:pafrag_a PORT MAP(en,zero,s2,s1,one,s0,y4);
    f6:pafrag_f PORT MAP(en,zero,s0,zero,s2,s1,y5);

    f7:pafrag_a PORT MAP(en,zero,s1,zero,s2,s0,y6);

    f8: logico port map(one,zero,one,zero,one,zero,
			zero,one,zero,one,zero,one,s2,zero,
			en,zero,s0,zero,s1,zero,y7);

END archde3x8;
--------------------------------------------------------
USE work.cypress.all;
USE work.mux_local.all;
ENTITY de4x16  IS
	PORT(
		 en : IN bit;
		 s0 : IN bit;
		 s1 : IN bit;
		 s2 : IN bit;
		 s3 : IN bit;
		 y0 : OUT bit;
		 y1 : OUT bit;
		 y2 : OUT bit;
		 y3 : OUT bit;
		 y4 : OUT bit;
		 y5 : OUT bit;
		 y6 : OUT bit;
		 y7 : OUT bit;
		 y8 : OUT bit;
		 y9 : OUT bit;
		 y10 : OUT bit;
		 y11 : OUT bit;
		 y12 : OUT bit;
		 y13 : OUT bit;
		 y14 : OUT bit;
		 y15 : OUT bit
	);
END de4x16 ;

ARCHITECTURE archde4x16 OF de4x16  IS
BEGIN

 y15 <= (((en and  s3 and  s2 and  s1 and  s0)));

 y14 <= (((not  s0) and (en and  s3 and  s2 and  s1)));

 y13 <= (((not  s1) and (en and  s3 and  s2 and  s0)));

 y12 <= (((not  s1 and not  s0) and (en and  s3 and  s2)));

 y11 <= (((not  s2) and (en and  s3 and  s1 and  s0)));

 y10 <= (((not  s2 and not  s0) and (en and  s3 and  s1)));

 y9 <= (((not  s2 and not  s1) and (en and  s3 and  s0)));

 y8 <= (((not  s2 and not  s1 and not  s0) and (en and  s3)));

 y7 <= (((not  s3) and (en and  s2 and  s1 and  s0)));

 y6 <= (((not  s3 and not  s0) and (en and  s2 and  s1)));

 y5 <= (((not  s3 and not  s1) and (en and  s2 and  s0)));

 y4 <= (((not  s3 and not  s1 and not  s0) and (en and  s2)));

 y3 <= (((not  s3 and not  s2) and (en and  s1 and  s0)));

 y2 <= (((not  s3 and not  s2 and not  s0) and (en and  s1)));

 y1 <= (((not  s3 and not  s2 and not  s1) and (en and  s0)));

 y0 <= (((not  s3 and not  s2 and not  s1 and not  s0) and (en)));

END archde4x16;
--------------------------------------------------------

USE work.cypress.all;
USE work.mux_local.all;
ENTITY mux1of2  IS
	PORT(
		en : IN bit;
		s : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		y : OUT bit
	);
END mux1of2 ;

ARCHITECTURE archmux1of2 OF mux1of2  IS

BEGIN

    U1: logico port map(one,zero,one,zero,en,zero,
			zero,one,zero,one,d0,zero,d1,zero,
			s,zero,one,zero,one,zero,y);

END archmux1of2;
--------------------------------------------------------

USE work.cypress.all;
USE work.mux_local.all;
ENTITY mux1of4  IS
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		d2 : IN bit;
		d3 : IN bit;
		y : OUT bit);
    attribute dont_touch of mux1of4: entity is true;
END mux1of4 ;

ARCHITECTURE archmux1of4 OF mux1of4  IS

    signal ez : bit;

BEGIN

    ez <= not en;

    U1: logico port map(s1,zero,one,zero,one,zero,
			d0,ez,d1,ez,d2,ez,d3,ez,
			s0,zero,one,zero,one,zero,y);

END archmux1of4;
--------------------------------------------------------

USE work.cypress.all;
USE work.mux_local.all;
entity mux2of4 is
    PORT(
	en : IN bit;
	s  : IN bit;
	a1 : IN bit;
	a0 : IN bit;
	b1 : IN bit;
	b0 : IN bit;
	y1 : OUT bit;
	y0 : OUT bit);
    attribute dont_touch of mux2of4: entity is true;
END mux2of4;

architecture archmux2of4 of mux2of4 is

signal az, fz : bit;

begin

    f1:pafrag_a port map(one,en,one,zero,one,zero,az);
    f2:pafrag_m port map(az,fz,a1,az,b1,az,a0,az,b0,az,y1,y0);
    f3:pafrag_f port map(s,zero,one,zero,one,zero,fz);

end archmux2of4;
--------------------------------------------------------

USE work.cypress.all;
USE work.mux_local.all;
ENTITY mux1of8  IS
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		s2 : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		d2 : IN bit;
		d3 : IN bit;
		d4 : IN bit;
		d5 : IN bit;
		d6 : IN bit;
		d7 : IN bit;
		y : OUT bit
	);
END mux1of8 ;

ARCHITECTURE archmux1of8 OF mux1of8  IS

    SIGNAL fx, gx : bit;
    attribute dont_touch of U1: label is true;

BEGIN

    U1: logico port map(one,zero,one,zero,one,zero,
			one,zero,one,zero,en,fx,gx,zero,
			s2,zero,en,zero,one,zero,y);

    U2: logico port map(s1,zero,one,zero,one,zero,
			one,d0,one,d1,one,d2,one,d3,
			s0,zero,one,zero,one,zero,fx);

    U3: logico port map(s1,zero,one,zero,one,zero,
			d4,zero,d5,zero,d6,zero,d7,zero,
			s0,zero,one,zero,one,zero,gx);

END archmux1of8;
--------------------------------------------------------

USE work.cypress.all;
USE work.mux_local.all;
ENTITY mux1of16  IS
	PORT(
		en : IN bit;
		s0 : IN bit;
		s1 : IN bit;
		s2 : IN bit;
		s3 : IN bit;
		d0 : IN bit;
		d1 : IN bit;
		d2 : IN bit;
		d3 : IN bit;
		d4 : IN bit;
		d5 : IN bit;
		d6 : IN bit;
		d7 : IN bit;
		d8 : IN bit;
		d9 : IN bit;
		d10 : IN bit;
		d11 : IN bit;
		d12 : IN bit;
		d13 : IN bit;
		d14 : IN bit;
		d15 : IN bit;
		y : OUT bit
	);
END mux1of16 ;

ARCHITECTURE archmux1of16 OF mux1of16  IS

    signal o1, o2, o3, o4 : bit;
    attribute dont_touch of U5: label is true;

BEGIN

    U1: logico port map(s1,zero,one,zero,one,zero,
			one,d0,one,d1,one,d2,one,d3,
			s0,zero,one,zero,one,zero,o1);

    U2: logico port map(s1,zero,one,zero,one,zero,
			d4,zero,d5,zero,d6,zero,d7,zero,
			s0,zero,one,zero,one,zero,o2);

    U3: logico port map(s1,zero,one,zero,one,zero,
			d8,zero,d9,zero,d10,zero,d11,zero,
			s0,zero,one,zero,one,zero,o3);

    U4: logico port map(s1,zero,one,zero,one,zero,
			d12,zero,d13,zero,d14,zero,d15,zero,
			s0,zero,one,zero,one,zero,o4);

    U5: logico port map(s3,zero,en,zero,one,zero,
			en,o1,o2,zero,o3,zero,o4,zero,
			s2,zero,en,zero,one,zero,y);

END archmux1of16;
--------------------------------------------------------
