--
--      Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--        as an unpublished work.
--

PACKAGE shifterpkg IS 

component SHIFT
    port(SI: IN bit;
	L  : IN bit;
	D  : IN bit;
	EN : IN bit;
	CLK: IN bit;
	R  : IN bit;
	Q  : INOUT bit);
end component;
 
component UNSR
    port(SL: IN bit;
	SR : IN bit;
	S0 : IN bit;
	S1 : IN bit;
	D  : IN bit;
	CLK: IN bit;
	R  : IN bit;
	Q  : INOUT bit);
end component;
 
COMPONENT shift4
    port(SI : IN bit;
         L  : IN bit;
         D3 : IN bit;
         D2 : IN bit;
         D1 : IN bit;
         D0 : IN bit;
         EN : IN bit;
         CLK: IN bit;
         R  : IN bit;
	 Q3 : INOUT bit;
	 Q2 : INOUT bit;
	 Q1 : INOUT bit;
	 Q0 : INOUT bit);
END COMPONENT;

COMPONENT shift8
    PORT (SI	: IN BIT;
	    L	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 	: IN BIT;
	    EN	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 	: INOUT BIT);
END COMPONENT;

COMPONENT shift16
    PORT (SI	: IN BIT;
	    L	: IN BIT;
	    D15,D14,D13,D12,D11,D10,D9,D8 	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 		: IN BIT;
	    EN	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q15,Q14,Q13,Q12,Q11,Q10,Q9,Q8 	: INOUT BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 		: INOUT BIT);
END COMPONENT;

COMPONENT unsr4 
    port(SL : IN bit;
         SR : IN bit;
         S0 : IN bit;
         S1 : IN bit;
         D3 : IN bit;
         D2 : IN bit;
         D1 : IN bit;
         D0 : IN bit;
	 CLK: IN bit;
         R  : IN bit;
         Q3 : INOUT bit;
         Q2 : INOUT bit;
         Q1 : INOUT bit;
         Q0 : INOUT bit);
END COMPONENT;

COMPONENT unsr8
    PORT (SL	: IN BIT;
	    SR	: IN BIT;
	    S0	: IN BIT;
	    S1	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 	: INOUT BIT);
END COMPONENT;

COMPONENT unsr16
    PORT (SL	: IN BIT;
	    SR	: IN BIT;
	    S0	: IN BIT;
	    S1	: IN BIT;
	    D15,D14,D13,D12,D11,D10,D9,D8 	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 		: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q15,Q14,Q13,Q12,Q11,Q10,Q9,Q8 	: INOUT BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 		: INOUT BIT);
END COMPONENT;
END shifterpkg;

package shifterpkg_local is
COMPONENT PAlcell
	PORT (
	    qs	: IN bit;	-- Async Set on FF(Q).

	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    qc	: IN bit;	-- Clock to FF(Q).
	    qr	: IN bit;	-- Async Reset on FF(Q).

	    az	: OUT bit;	-- Output of AND A.
	    oz	: OUT bit;	-- Output of MUX O.
	    qz	: OUT bit;	-- Output of FF  Q.
	    nz	: OUT bit;	-- Output of MUX N.
	    fz	: OUT bit	-- Output of AND F.
	);
    END COMPONENT;
end shifterpkg_local ;

---------------------------------------------
use work.cypress.all; 
use work.shifterpkg_local.all; 

entity SHIFT is
    port(SI : IN bit;
         L  : IN bit;
         D  : IN bit;
         EN : IN bit;
         CLK: IN bit;
         R  : IN bit;
         Q  : INOUT bit);
end SHIFT;

architecture archSHIFT of SHIFT is
     
begin

    U0: palcell port map (zero,
			    l,zero,one,zero,one,zero,
			    q,zero,si,zero,d,zero,d,zero,
			    en,zero,one,zero,one,zero,
			    clk,r,open,open,q,open,open);
     
end archSHIFT;

use work.cypress.all; 
use work.shifterpkg_local.all; 
 
entity UNSR is
    port(SL : IN bit;
         SR : IN bit;
         S0 : IN bit;
         S1 : IN bit;
         D  : IN bit;
         CLK: IN bit;
         R  : IN bit;
	 Q  : INOUT bit);
 end UNSR;
 
 architecture archUNSR of UNSR is

 begin

    U0: palcell port map (zero,
			    s1,zero,one,zero,one,zero,
			    q,zero,sr,zero,sl,zero,d,zero,
			    s0,zero,one,zero,one,zero,
			    clk,r,open,open,q,open,open);

 end archUNSR;

-------------------------------------------------
--
--	SHIFT Register 4-bits
--

entity SHIFT4 is
    port(SI : IN bit;
         L  : IN bit;
         D3 : IN bit;
         D2 : IN bit;
         D1 : IN bit;
         D0 : IN bit;
         EN : IN bit;
         CLK: IN bit;
         R  : IN bit;
	 Q3 : INOUT bit;
	 Q2 : INOUT bit;
	 Q1 : INOUT bit;
	 Q0 : INOUT bit);
end SHIFT4;

architecture archSHIFT4 of SHIFT4 is

BEGIN
	u1:shift port map(si,l,d0,en,clk,r,q0);
	u2:shift port map(q0,l,d1,en,clk,r,q1);
	u3:shift port map(q1,l,d2,en,clk,r,q2);
	u4:shift port map(q2,l,d3,en,clk,r,q3);
    
end archSHIFT4;

--
--	SHIFT Register 8-bits
--

ENTITY shift8 is
    PORT (SI	: IN BIT;
	    L	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 	: IN BIT;
	    EN	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 	: INOUT BIT);
END shift8;

ARCHITECTURE archSHIFT8 of shift8 IS

BEGIN

    U1: shift4 port map (si,l,d3,d2,d1,d0,en,clk,r,q3,q2,q1,q0);
    U2: shift4 port map (q3,l,d7,d6,d5,d4,en,clk,r,q7,q6,q5,q4);

END archSHIFT8;

--
--	SHIFT Register 16-bits
--

ENTITY shift16 is
    PORT (SI	: IN BIT;
	    L	: IN BIT;
	    D15,D14,D13,D12,D11,D10,D9,D8 	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 		: IN BIT;
	    EN	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q15,Q14,Q13,Q12,Q11,Q10,Q9,Q8 	: INOUT BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 		: INOUT BIT);
END shift16;

ARCHITECTURE archSHIFT16 of shift16 IS

BEGIN

    U1: shift4 port map ( si,l, d3, d2, d1, d0,en,clk,r, q3, q2, q1, q0);
    U2: shift4 port map ( q3,l, d7, d6, d5, d4,en,clk,r, q7, q6, q5, q4);
    U3: shift4 port map ( q7,l,d11,d10, d9, d8,en,clk,r,q11,q10, q9, q8);
    U4: shift4 port map (q11,l,d15,d14,d13,d12,en,clk,r,q15,q14,q13,q12);

END archSHIFT16;

----------------------------------------------------

--
--	Universal Shift Register 8-bits
--

entity UNSR4 is
    port(SL : IN bit;
         SR : IN bit;
         S0 : IN bit;
         S1 : IN bit;
         D3 : IN bit;
         D2 : IN bit;
         D1 : IN bit;
         D0 : IN bit;
	 CLK: IN bit;
         R  : IN bit;
         Q3 : INOUT bit;
         Q2 : INOUT bit;
         Q1 : INOUT bit;
         Q0 : INOUT bit);
end UNSR4;

architecture archUNSR4 of UNSR4 is

BEGIN
	u1:unsr port map(sl,q1,s0,s1,d0,clk,r,q0);
	u2:unsr port map(q0,q2,s0,s1,d1,clk,r,q1);
	u3:unsr port map(q1,q3,s0,s1,d2,clk,r,q2);
	u4:unsr port map(q2,sr,s0,s1,d3,clk,r,q3);
    
end archUNSR4;

--
--	Universal Shift Register 8-bits
--

ENTITY unsr8 is
    PORT( SL	: IN BIT;
	    SR	: IN BIT;
	    S0	: IN BIT;
	    S1	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 	: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 	: INOUT BIT);
END unsr8;

ARCHITECTURE archunsr8 of unsr8 IS

BEGIN

    U1: unsr4 port map (sl,q4,s0,s1,d3,d2,d1,d0,clk,r,q3,q2,q1,q0);
    U2: unsr4 port map (q3,sr,s0,s1,d7,d6,d5,d4,clk,r,q7,q6,q5,q4);

END archunsr8;

--
--	Universal Shift Register 16-bits
--

ENTITY unsr16 is
    PORT( SL	: IN BIT;
	    SR	: IN BIT;
	    S0	: IN BIT;
	    S1	: IN BIT;
	    D15,D14,D13,D12,D11,D10,D9,D8 	: IN BIT;
	    D7,D6,D5,D4,D3,D2,D1,D0 		: IN BIT;
	    CLK	: IN BIT;
	    R	: IN BIT;
	    Q15,Q14,Q13,Q12,Q11,Q10,Q9,Q8 	: INOUT BIT;
	    Q7,Q6,Q5,Q4,Q3,Q2,Q1,Q0 		: INOUT BIT);
END unsr16;

ARCHITECTURE archunsr16 of unsr16 IS

BEGIN

    U1:unsr4 port map( sl, q4,s0,s1, d3, d2, d1, d0,clk,r, q3, q2, q1, q0);
    U2:unsr4 port map( q3, q8,s0,s1, d7, d6, d5, d4,clk,r, q7, q6, q5, q4);
    U3:unsr4 port map( q7,q12,s0,s1,d11,d10, d9, d8,clk,r,q11,q10, q9, q8);
    U4:unsr4 port map(q11, sr,s0,s1,d15,d14,d13,d12,clk,r,q15,q14,q13,q12);

END archunsr16;
