--
--	Copyright Cypress Semiconductor Corporation, 1995,1996
--		as an unpublished work.
--

--
--	TTL82
--

package ttlspc_local is
    COMPONENT PAfrag_a
	PORT (
	    a1	: IN bit;	-- Non-invert to AND A.
	    a2	: IN bit;	-- Invert to AND A.
	    a3	: IN bit;	-- Non-invert to AND A.
	    a4	: IN bit;	-- Invert to AND A.
	    a5	: IN bit;	-- Non-invert to AND A.
	    a6	: IN bit;	-- Invert to AND A.

	    az	: OUT bit	-- Output of AND A.
	);
    END COMPONENT;
    COMPONENT PAfrag_m		-- Fragment M.
	PORT (
	    os	: IN bit;	-- Select to MUX O.
	    nsi	: IN bit;	-- Select to MUX N.

	    b1	: IN bit;	-- Non-invert to AND B.
	    b2	: IN bit;	-- Invert to AND B.

	    c1	: IN bit;	-- Non-invert to AND C.
	    c2	: IN bit;	-- Invert to AND C.

	    d1	: IN bit;	-- Non-invert to AND D.
	    d2	: IN bit;	-- Invert to AND D.

	    e1	: IN bit;	-- Non-invert to AND E.
	    e2	: IN bit;	-- Invert to AND E.

	    oz	: OUT bit;	-- Output of MUX O.
	    nz	: OUT bit	-- Output of MUX N.
	);
    END COMPONENT;
    COMPONENT PAfrag_f		-- Fragment AND F.
	PORT (
	    f1	: IN bit;	-- Non-invert to AND F.
	    f2	: IN bit;	-- Invert to AND F.
	    f3	: IN bit;	-- Non-invert to AND F.
	    f4	: IN bit;	-- Invert to AND F.
	    f5	: IN bit;	-- Non-invert to AND F.
	    f6	: IN bit;	-- Invert to AND F.

	    fz	: OUT bit	-- Output of AND F.
	);
    END COMPONENT;
end ttlspc_local ;

USE WORK.ttlspc_local.ALL;

ENTITY ttl82 IS
	PORT (C0 : IN BIT;
	      A1, A2, B1, B2: IN BIT;
              S1, S2: OUT BIT;
              C2: OUT BIT);
END ttl82;

ARCHITECTURE archttl82 OF ttl82 IS

    signal c2tmp : bit;
    signal VL1N100: bit;
    signal VL1N102: bit;
    signal VL1N105: bit;
    signal VL1N107: bit;
    signal VL1N109: bit;
    signal VL1N116: bit;
    signal VL1N118: bit;
    signal VL1N121: bit;
    signal VL1N126: bit;
    signal VL1N127: bit;
    signal VL1N134: bit;
    signal VL1N138: bit;
    signal VL1N141: bit;
    signal VL1N143: bit;
    signal VL1N145: bit;
    signal VL1N45: bit;
    signal VL1N47: bit;
    signal VL1N53: bit;
    signal VL1N65: bit;
    signal VL1N67: bit;
    signal VL1N69: bit;
    signal VL1N87: bit;
    signal VL1N89: bit;
    signal VL1N98: bit;
    signal VL1I113_N_1: bit;
    signal VL1I113_N_2: bit;
    signal VL1I113_QL2_OZ: bit;
    signal VL1I114_N_1: bit;
    signal VL1I114_N_2: bit;
    signal VL1I114_QL2_OZ: bit;
    signal VL1I115_N_1: bit;
    signal VL1I115_N_2: bit;
    signal VL1I115_QL2_OZ: bit;
    signal VL1I123_N_1: bit;
    signal VL1I123_N_2: bit;
    signal VL1I123_QL2_OZ: bit;
    signal VL1I124_N_1: bit;
    signal VL1I124_N_2: bit;
    signal VL1I124_QL2_OZ: bit;
    signal VL1I125_N_1: bit;
    signal VL1I125_N_2: bit;
    signal VL1I125_QL2_OZ: bit;
    signal VL1I18_N_1: bit;
    signal VL1I18_N_2: bit;
    signal VL1I18_QL1_NZ: bit;
    signal VL1I3_N_1: bit;
    signal VL1I3_N_2: bit;
    signal VL1I3_QL1_NZ: bit;
    
begin
    
    VL1I1_QL1_VL1I12: PAFRAG_A
        port map(A1 => C0,
                 A2 => zero,
                 A3 => VL1N53,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N65);
    
    VL1I10_QL1_VL1I12: PAFRAG_A
        port map(A1 => C0,
                 A2 => zero,
                 A3 => B1,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N107);
    
    VL1I11_QL1_VL1I12: PAFRAG_A
        port map(A1 => B1,
                 A2 => zero,
                 A3 => A1,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N109);
    
    VL1I113_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I113_N_2);
    
    VL1I113_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I113_N_2,
                 NSI => VL1I113_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N141,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N141,
                 OZ => VL1I113_QL2_OZ,
                 NZ => VL1N116);
    
    VL1I113_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N138,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I113_N_1);
    
    VL1I114_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I114_N_2);
    
    VL1I114_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I114_N_2,
                 NSI => VL1I114_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N145,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N145,
                 OZ => VL1I114_QL2_OZ,
                 NZ => VL1N118);
    
    VL1I114_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N143,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I114_N_1);
    
    VL1I115_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I115_N_2);
    
    VL1I115_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I115_N_2,
                 NSI => VL1I115_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N118,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N118,
                 OZ => VL1I115_QL2_OZ,
                 NZ => VL1N121);
    
    VL1I115_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N116,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I115_N_1);
    
    VL1I120_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N121,
                 AZ => S2);
    
    VL1I123_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I123_N_2);
    
    VL1I123_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I123_N_2,
                 NSI => VL1I123_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N67,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N67,
                 OZ => VL1I123_QL2_OZ,
                 NZ => VL1N126);
    
    VL1I123_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N65,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I123_N_1);
    
    VL1I124_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I124_N_2);
    
    VL1I124_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I124_N_2,
                 NSI => VL1I124_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N134,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N134,
                 OZ => VL1I124_QL2_OZ,
                 NZ => VL1N127);
    
    VL1I124_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N69,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I124_N_1);
    
    VL1I125_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I125_N_2);
    
    VL1I125_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I125_N_2,
                 NSI => VL1I125_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N127,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N127,
                 OZ => VL1I125_QL2_OZ,
                 NZ => S1);
    
    VL1I125_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N126,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I125_N_1);
    
    VL1I17_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N47,
                 AZ => c2tmp);
    
    VL1I18_QL1_VL1I1: PAFRAG_M
        port map(OS => VL1I18_N_2,
                 NSI => VL1I18_N_1,
                 B1 => VL1N102,
                 B2 => zero,
                 C1 => one,
                 C2 => VL1N102,
                 D1 => one,
                 D2 => VL1N102,
                 E1 => VL1N102,
                 E2 => zero,
                 OZ => VL1N47,
                 NZ => VL1I18_QL1_NZ);
    
    VL1I18_QL2_VL1I1: PAFRAG_F
        port map(F1 => VL1N100,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I18_N_1);
    
    VL1I18_QL3_VL1I12: PAFRAG_A
        port map(A1 => VL1N98,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I18_N_2);
    
    VL1I19_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N53,
                 A2 => zero,
                 A3 => VL1N87,
                 A4 => zero,
                 A5 => VL1N89,
                 A6 => zero,
                 AZ => VL1N145);
    
    VL1I2_QL1_VL1I12: PAFRAG_A
        port map(A1 => C0,
                 A2 => zero,
                 A3 => A1,
                 A4 => zero,
                 A5 => B1,
                 A6 => zero,
                 AZ => VL1N134);
    
    VL1I20_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N89,
                 A2 => zero,
                 A3 => c2tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N143);
    
    VL1I21_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N87,
                 A2 => zero,
                 A3 => c2tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N141);
    
    VL1I22_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N53,
                 A2 => zero,
                 A3 => c2tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N138);
    
    VL1I23_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N53,
                 A2 => zero,
                 A3 => VL1N87,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N98);
    
    VL1I24_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N53,
                 A2 => zero,
                 A3 => VL1N89,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N100);
    
    VL1I25_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N89,
                 A2 => zero,
                 A3 => VL1N87,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N102);
    
    VL1I29_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => A2,
                 AZ => VL1N87);
    
    VL1I3_QL1_VL1I1: PAFRAG_M
        port map(OS => VL1I3_N_2,
                 NSI => VL1I3_N_1,
                 B1 => VL1N109,
                 B2 => zero,
                 C1 => one,
                 C2 => VL1N109,
                 D1 => one,
                 D2 => VL1N109,
                 E1 => VL1N109,
                 E2 => zero,
                 OZ => VL1N45,
                 NZ => VL1I3_QL1_NZ);
    
    VL1I3_QL2_VL1I1: PAFRAG_F
        port map(F1 => VL1N107,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I3_N_1);
    
    VL1I3_QL3_VL1I12: PAFRAG_A
        port map(A1 => VL1N105,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I3_N_2);
    
    VL1I30_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => B2,
                 AZ => VL1N89);
    
    VL1I4_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N45,
                 AZ => VL1N53);
    
    VL1I7_QL1_VL1I12: PAFRAG_A
        port map(A1 => A1,
                 A2 => zero,
                 A3 => VL1N53,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N67);
    
    VL1I8_QL1_VL1I12: PAFRAG_A
        port map(A1 => B1,
                 A2 => zero,
                 A3 => VL1N53,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N69);
    
    VL1I9_QL1_VL1I12: PAFRAG_A
        port map(A1 => C0,
                 A2 => zero,
                 A3 => A1,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N105);
    
    C2 <= c2tmp;

END archttl82;

--
--	TTL83
--

USE WORK.ttlspc_local.ALL;

ENTITY ttl83 IS
	PORT (C0 : IN BIT;
	      A1, A2, A3, A4, B1, B2, B3, B4 : IN BIT;
              S1, S2, S3, S4: OUT BIT;
              C4: OUT BIT);
END ttl83;

ARCHITECTURE archttl83 OF ttl83 IS

    signal VL1N103: bit;
    signal VL1N105: bit;
    signal VL1N107: bit;
    signal VL1N109: bit;
    signal VL1N113: bit;
    signal VL1N115: bit;
    signal VL1N120: bit;
    signal VL1N123: bit;
    signal VL1N127: bit;
    signal VL1N132: bit;
    signal VL1N134: bit;
    signal VL1N136: bit;
    signal VL1N140: bit;
    signal VL1N150: bit;
    signal VL1N152: bit;
    signal VL1N246: bit;
    signal VL1N252: bit;
    signal VL1N285: bit;
    signal VL1N295: bit;
    signal VL1N305: bit;
    signal VL1N329: bit;
    signal VL1N337: bit;
    signal VL1N342: bit;
    signal VL1N343: bit;
    signal VL1N346: bit;
    signal VL1N356: bit;
    signal VL1N358: bit;
    signal VL1N360: bit;
    signal VL1N367: bit;
    signal VL1N369: bit;
    signal VL1N376: bit;
    signal VL1N378: bit;
    signal VL1N380: bit;
    signal VL1N399: bit;
    signal VL1N401: bit;
    signal VL1N407: bit;
    signal VL1N409: bit;
    signal VL1N83: bit;
    signal VL1N85: bit;
    signal VL1N92: bit;
    signal VL1N94: bit;
    signal VL1I325_N_1: bit;
    signal VL1I325_N_2: bit;
    signal VL1I325_QL2_OZ: bit;
    signal VL1I326_N_1: bit;
    signal VL1I326_N_2: bit;
    signal VL1I326_QL2_OZ: bit;
    signal VL1I327_N_1: bit;
    signal VL1I327_N_2: bit;
    signal VL1I327_QL2_OZ: bit;
    signal VL1I390_N_1: bit;
    signal VL1I390_N_2: bit;
    signal VL1I390_QL2_OZ: bit;
    signal VL1I394_N_1: bit;
    signal VL1I394_N_2: bit;
    signal VL1I394_QL2_OZ: bit;
    signal VL1I396_N_1: bit;
    signal VL1I396_N_2: bit;
    signal VL1I396_QL2_OZ: bit;
    signal VL1I397_N_1: bit;
    signal VL1I397_N_2: bit;
    signal VL1I397_QL2_OZ: bit;
    signal VL1I406_N_1: bit;
    signal VL1I406_N_2: bit;
    signal VL1I406_QL2_OZ: bit;
    
begin

    VL1I111_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N342,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N127,
                 AZ => VL1N115);
    
    VL1I129_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N337,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N132,
                 AZ => VL1N150);
    
    VL1I161_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => C0,
                 AZ => VL1N246);
    
    VL1I261_QL1_VL1I12: PAFRAG_A
        port map(A1 => B4,
                 A2 => zero,
                 A3 => A4,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N305);
    
    VL1I262_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => B4,
                 A5 => one,
                 A6 => A4,
                 AZ => VL1N132);
    
    VL1I268_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => B3,
                 A5 => one,
                 A6 => A3,
                 AZ => VL1N127);
    
    VL1I274_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => B2,
                 A5 => one,
                 A6 => A2,
                 AZ => VL1N105);
    
    VL1I280_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => B1,
                 A5 => one,
                 A6 => A1,
                 AZ => VL1N92);
    
    VL1I325_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I325_N_2);
    
    VL1I325_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I325_N_2,
                 NSI => VL1I325_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N113,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N113,
                 OZ => VL1I325_QL2_OZ,
                 NZ => S3);
    
    VL1I325_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N115,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I325_N_1);
    
    VL1I326_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I326_N_2);
    
    VL1I326_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I326_N_2,
                 NSI => VL1I326_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N329,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N329,
                 OZ => VL1I326_QL2_OZ,
                 NZ => S2);
    
    VL1I326_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N103,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I326_N_1);
    
    VL1I327_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I327_N_2);
    
    VL1I327_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I327_N_2,
                 NSI => VL1I327_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N83,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N83,
                 OZ => VL1I327_QL2_OZ,
                 NZ => S1);
    
    VL1I327_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N85,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I327_N_1);
    
    VL1I334_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N305,
                 AZ => VL1N337);
    
    VL1I338_QL1_VL1I12: PAFRAG_A
        port map(A1 => B3,
                 A2 => zero,
                 A3 => A3,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N295);
    
    VL1I339_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N295,
                 AZ => VL1N342);
    
    VL1I344_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N343,
                 AZ => VL1N285);
    
    VL1I345_QL1_VL1I12: PAFRAG_A
        port map(A1 => B2,
                 A2 => zero,
                 A3 => A2,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N343);
    
    VL1I347_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N346,
                 AZ => VL1N252);
    
    VL1I348_QL1_VL1I12: PAFRAG_A
        port map(A1 => B1,
                 A2 => zero,
                 A3 => A1,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N346);
    
    VL1I352_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N92,
                 A2 => zero,
                 A3 => VL1N337,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N356);
    
    VL1I353_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N342,
                 A2 => zero,
                 A3 => VL1N285,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N358);
    
    VL1I354_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N356,
                 A2 => zero,
                 A3 => VL1N358,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N360);
    
    VL1I362_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N337,
                 A2 => zero,
                 A3 => VL1N342,
                 A4 => zero,
                 A5 => VL1N285,
                 A6 => zero,
                 AZ => VL1N367);
    
    VL1I363_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N252,
                 A2 => zero,
                 A3 => VL1N246,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N369);
    
    VL1I364_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N367,
                 A2 => zero,
                 A3 => VL1N369,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N140);
    
    VL1I371_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N378,
                 A2 => zero,
                 A3 => VL1N380,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N376);
    
    VL1I373_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N342,
                 A2 => zero,
                 A3 => VL1N285,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N378);
    
    VL1I374_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N252,
                 A2 => zero,
                 A3 => VL1N246,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N380);
    
    VL1I390_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I390_N_2);
    
    VL1I390_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I390_N_2,
                 NSI => VL1I390_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => VL1N152,
                 D2 => zero,
                 E1 => one,
                 E2 => VL1N152,
                 OZ => VL1I390_QL2_OZ,
                 NZ => S4);
    
    VL1I390_QL3_VL1I1: PAFRAG_F
        port map(F1 => VL1N150,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I390_N_1);
    
    VL1I394_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I394_N_2);
    
    VL1I394_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I394_N_2,
                 NSI => VL1I394_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I394_QL2_OZ,
                 NZ => VL1N407);
    
    VL1I394_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N127,
                 F3 => one,
                 F4 => VL1N123,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I394_N_1);
    
    VL1I396_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I396_N_2);
    
    VL1I396_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I396_N_2,
                 NSI => VL1I396_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I396_QL2_OZ,
                 NZ => VL1N399);
    
    VL1I396_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N132,
                 F3 => one,
                 F4 => VL1N134,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I396_N_1);
    
    VL1I397_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I397_N_2);
    
    VL1I397_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I397_N_2,
                 NSI => VL1I397_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I397_QL2_OZ,
                 NZ => VL1N401);
    
    VL1I397_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N136,
                 F3 => one,
                 F4 => VL1N360,
                 F5 => one,
                 F6 => VL1N140,
                 FZ => VL1I397_N_1);
    
    VL1I398_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N399,
                 A5 => one,
                 A6 => VL1N401,
                 AZ => C4);
    
    VL1I405_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N407,
                 A5 => one,
                 A6 => VL1N409,
                 AZ => VL1N152);
    
    VL1I406_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I406_N_2);
    
    VL1I406_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I406_N_2,
                 NSI => VL1I406_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I406_QL2_OZ,
                 NZ => VL1N409);
    
    VL1I406_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N120,
                 F3 => one,
                 F4 => VL1N376,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I406_N_1);
    
    VL1I47_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N127,
                 A2 => zero,
                 A3 => VL1N337,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N134);
    
    VL1I49_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N105,
                 A2 => zero,
                 A3 => VL1N337,
                 A4 => zero,
                 A5 => VL1N342,
                 A6 => zero,
                 AZ => VL1N136);
    
    VL1I54_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N105,
                 A2 => zero,
                 A3 => VL1N342,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N123);
    
    VL1I55_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N92,
                 A2 => zero,
                 A3 => VL1N342,
                 A4 => zero,
                 A5 => VL1N285,
                 A6 => zero,
                 AZ => VL1N120);
    
    VL1I57_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N285,
                 A2 => zero,
                 A3 => VL1N252,
                 A4 => zero,
                 A5 => VL1N246,
                 A6 => zero,
                 AZ => VL1N109);
    
    VL1I58_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N92,
                 A2 => zero,
                 A3 => VL1N285,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N107);
    
    VL1I7_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => VL1N105,
                 A3 => one,
                 A4 => VL1N107,
                 A5 => one,
                 A6 => VL1N109,
                 AZ => VL1N113);
    
    VL1I75_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N252,
                 A2 => zero,
                 A3 => VL1N246,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N94);
    
    VL1I77_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N252,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N92,
                 AZ => VL1N85);
    
    VL1I79_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N246,
                 AZ => VL1N83);
    
    VL1I91_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N92,
                 A5 => one,
                 A6 => VL1N94,
                 AZ => VL1N329);
    
    VL1I99_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N285,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N105,
                 AZ => VL1N103);

END archttl83;

--
--	TTL85
--

USE WORK.ttlspc_local.ALL;

ENTITY ttl85 IS
        PORT (A0, A1, A2, A3, B0, B1, B2, B3: IN BIT;
 	      albi,aebi,agbi: IN BIT;
 	      alb,aeb,agb: OUT BIT);
END ttl85;

ARCHITECTURE archttl85 OF ttl85 IS

    signal VL1N101: bit;
    signal VL1N126: bit;
    signal VL1N127: bit;
    signal VL1N142: bit;
    signal VL1N143: bit;
    signal VL1N162: bit;
    signal VL1N163: bit;
    signal VL1N217: bit;
    signal VL1N218: bit;
    signal VL1N255: bit;
    signal VL1N256: bit;
    signal VL1N289: bit;
    signal VL1N291: bit;
    signal VL1N80: bit;
    signal VL1N82: bit;
    signal VL1N83: bit;
    signal VL1N85: bit;
    signal VL1N99: bit;
    signal N_1: bit;
    signal N_11: bit;
    signal N_12: bit;
    signal N_13: bit;
    signal N_14: bit;
    signal N_16: bit;
    signal N_19: bit;
    signal N_2: bit;
    signal N_21: bit;
    signal N_23: bit;
    signal VL1I125_NZ: bit;
    signal VL1I141_NZ: bit;
    signal VL1I164_NZ: bit;
    signal VL1I216_NZ: bit;
    signal VL1I257_NZ: bit;
    signal VL1I98_NZ: bit;
    
begin

    VL1I125_VL1I1: PAFRAG_M
        port map(OS => VL1N127,
                 NSI => VL1N126,
                 B1 => one,
                 B2 => zero,
                 C1 => zero,
                 C2 => one,
                 D1 => zero,
                 D2 => one,
                 E1 => one,
                 E2 => zero,
                 OZ => N_2,
                 NZ => VL1I125_NZ);
    
    VL1I128_VL1I12: PAFRAG_A
        port map(A1 => A2,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N127);
    
    VL1I129_VL1I1: PAFRAG_F
        port map(F1 => B2,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N126);
    
    VL1I139_VL1I1: PAFRAG_F
        port map(F1 => B1,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N142);
    
    VL1I140_VL1I12: PAFRAG_A
        port map(A1 => A1,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N143);
    
    VL1I141_VL1I1: PAFRAG_M
        port map(OS => VL1N143,
                 NSI => VL1N142,
                 B1 => zero,
                 B2 => one,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => N_12,
                 NZ => VL1I141_NZ);
    
    VL1I164_VL1I1: PAFRAG_M
        port map(OS => VL1N162,
                 NSI => VL1N163,
                 B1 => zero,
                 B2 => one,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => N_11,
                 NZ => VL1I164_NZ);
    
    VL1I165_VL1I12: PAFRAG_A
        port map(A1 => A0,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N162);
    
    VL1I166_VL1I1: PAFRAG_F
        port map(F1 => B0,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N163);
    
    VL1I191_VL1I12: PAFRAG_A
        port map(A1 => B3,
                 A2 => A3,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => N_23);
    
    VL1I192_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => A3,
                 F6 => B3,
                 FZ => VL1N82);
    
    VL1I199_VL1I12: PAFRAG_A
        port map(A1 => N_1,
                 A2 => zero,
                 A3 => B2,
                 A4 => A2,
                 A5 => one,
                 A6 => zero,
                 AZ => N_16);
    
    VL1I203_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => zero,
                 F3 => N_1,
                 F4 => zero,
                 F5 => A2,
                 F6 => B2,
                 FZ => VL1N80);
    
    VL1I205_VL1I12: PAFRAG_A
        port map(A1 => N_1,
                 A2 => zero,
                 A3 => N_2,
                 A4 => zero,
                 A5 => B1,
                 A6 => A1,
                 AZ => N_14);
    
    VL1I207_VL1I1: PAFRAG_F
        port map(F1 => N_1,
                 F2 => zero,
                 F3 => N_2,
                 F4 => zero,
                 F5 => A1,
                 F6 => B1,
                 FZ => VL1N83);
    
    VL1I209_VL1I12: PAFRAG_A
        port map(A1 => N_1,
                 A2 => zero,
                 A3 => N_2,
                 A4 => N_12,
                 A5 => B0,
                 A6 => A0,
                 AZ => N_19);
    
    VL1I210_VL1I1: PAFRAG_F
        port map(F1 => N_1,
                 F2 => zero,
                 F3 => N_2,
                 F4 => N_12,
                 F5 => A0,
                 F6 => B0,
                 FZ => VL1N85);
    
    VL1I212_VL1I12: PAFRAG_A
        port map(A1 => VL1N289,
                 A2 => zero,
                 A3 => N_1,
                 A4 => N_12,
                 A5 => N_2,
                 A6 => N_11,
                 AZ => N_21);
    
    VL1I213_VL1I1: PAFRAG_F
        port map(F1 => VL1N291,
                 F2 => zero,
                 F3 => N_1,
                 F4 => N_12,
                 F5 => N_2,
                 F6 => N_11,
                 FZ => N_13);
    
    VL1I214_VL1I12: PAFRAG_A
        port map(A1 => AEBI,
                 A2 => zero,
                 A3 => N_1,
                 A4 => N_12,
                 A5 => N_2,
                 A6 => N_11,
                 AZ => AEB);
    
    VL1I216_VL1I1: PAFRAG_M
        port map(OS => VL1N218,
                 NSI => VL1N217,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => AGB,
                 NZ => VL1I216_NZ);
    
    VL1I219_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => VL1N82,
                 A3 => one,
                 A4 => VL1N80,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N218);
    
    VL1I220_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N83,
                 F3 => one,
                 F4 => VL1N85,
                 F5 => one,
                 F6 => N_21,
                 FZ => VL1N217);
    
    VL1I253_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => N_14,
                 F3 => one,
                 F4 => N_19,
                 F5 => one,
                 F6 => N_13,
                 FZ => VL1N256);
    
    VL1I254_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => N_23,
                 A3 => one,
                 A4 => N_16,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N255);
    
    VL1I257_VL1I1: PAFRAG_M
        port map(OS => VL1N255,
                 NSI => VL1N256,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => ALB,
                 NZ => VL1I257_NZ);
    
    VL1I287_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => AGBI,
                 A3 => one,
                 A4 => AEBI,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N291);
    
    VL1I288_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => ALBI,
                 F3 => one,
                 F4 => AEBI,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N289);
    
    VL1I96_VL1I12: PAFRAG_A
        port map(A1 => A3,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N99);
    
    VL1I97_VL1I1: PAFRAG_F
        port map(F1 => B3,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N101);
    
    VL1I98_VL1I1: PAFRAG_M
        port map(OS => VL1N99,
                 NSI => VL1N101,
                 B1 => one,
                 B2 => zero,
                 C1 => zero,
                 C2 => one,
                 D1 => zero,
                 D2 => one,
                 E1 => one,
                 E2 => zero,
                 OZ => N_1,
                 NZ => VL1I98_NZ);

END archttl85;

--
--	TTL148
--

USE WORK.ttlspc_local.ALL;

ENTITY ttl148 IS
PORT (EI, I0, I1, I2, I3, I4, I5, I6, I7 : IN BIT;
	A0,A1,A2,GS,EO : OUT BIT);
END ttl148;

ARCHITECTURE archttl148 of ttl148 IS

    signal EOtmp : bit;
    signal VL1N253: bit;
    signal VL1N265: bit;
    signal VL1N267: bit;
    signal VL1N313: bit;
    signal VL1N314: bit;
    signal VL1N325: bit;
    signal VL1N334: bit;
    signal VL1N345: bit;
    signal VL1N349: bit;
    signal VL1N379: bit;
    signal VL1N450: bit;
    signal VL1N451: bit;
    signal VL1N49: bit;
    signal VL1N499: bit;
    signal VL1N51: bit;
    signal VL1N55: bit;
    signal VL1N57: bit;
    signal VL1N59: bit;
    signal VL1N61: bit;
    signal VL1N65: bit;
    signal VL1N67: bit;
    signal VL1N69: bit;
    signal VL1N71: bit;
    signal VL1I249_OZ: bit;
    signal VL1I264_OZ: bit;
    signal VL1I315_OZ: bit;
    signal VL1I346_OZ: bit;
    signal VL1I452_NZ: bit;
    
begin

    VL1I197_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => I7,
                 AZ => VL1N499);
    
    VL1I248_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N51,
                 F3 => one,
                 F4 => VL1N379,
                 F5 => one,
                 F6 => VL1N55,
                 FZ => VL1N253);
    
    VL1I249_VL1I1: PAFRAG_M
        port map(OS => VL1N267,
                 NSI => VL1N253,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => zero,
                 D2 => one,
                 E1 => one,
                 E2 => VL1N49,
                 OZ => VL1I249_OZ,
                 NZ => A2);
    
    VL1I263_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N69,
                 F3 => one,
                 F4 => VL1N67,
                 F5 => one,
                 F6 => VL1N65,
                 FZ => VL1N265);
    
    VL1I264_VL1I1: PAFRAG_M
        port map(OS => VL1N334,
                 NSI => VL1N265,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => zero,
                 D2 => one,
                 E1 => one,
                 E2 => VL1N71,
                 OZ => VL1I264_OZ,
                 NZ => A0);
    
    VL1I302_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N267);
    
    VL1I312_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N313);
    
    VL1I315_VL1I1: PAFRAG_M
        port map(OS => VL1N313,
                 NSI => VL1N314,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => zero,
                 D2 => one,
                 E1 => one,
                 E2 => VL1N325,
                 OZ => VL1I315_OZ,
                 NZ => A1);
    
    VL1I316_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N61,
                 F3 => one,
                 F4 => VL1N59,
                 F5 => one,
                 F6 => VL1N57,
                 FZ => VL1N314);
    
    VL1I335_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N334);
    
    VL1I346_VL1I1: PAFRAG_M
        port map(OS => VL1N349,
                 NSI => VL1N345,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I346_OZ,
                 NZ => GS);
    
    VL1I347_VL1I1: PAFRAG_F
        port map(F1 => EOtmp,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => EI,
                 FZ => VL1N345);
    
    VL1I348_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N349);
    
    VL1I376_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => I6,
                 A3 => one,
                 A4 => EI,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N379);
    
    VL1I377_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => I7,
                 F3 => one,
                 F4 => EI,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N55);
    
    VL1I380_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => I5,
                 F3 => one,
                 F4 => EI,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N51);
    
    VL1I381_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => I4,
                 A3 => one,
                 A4 => EI,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N49);
    
    VL1I384_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => I7,
                 F3 => one,
                 F4 => EI,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N57);
    
    VL1I385_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => I6,
                 A5 => one,
                 A6 => EI,
                 AZ => VL1N59);
    
    VL1I386_VL1I1: PAFRAG_F
        port map(F1 => I4,
                 F2 => zero,
                 F3 => I5,
                 F4 => I3,
                 F5 => one,
                 F6 => EI,
                 FZ => VL1N61);
    
    VL1I389_VL1I12: PAFRAG_A
        port map(A1 => I4,
                 A2 => zero,
                 A3 => I5,
                 A4 => I2,
                 A5 => one,
                 A6 => EI,
                 AZ => VL1N325);
    
    VL1I391_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => I7,
                 F3 => one,
                 F4 => EI,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1N65);
    
    VL1I392_VL1I12: PAFRAG_A
        port map(A1 => I6,
                 A2 => zero,
                 A3 => one,
                 A4 => I5,
                 A5 => one,
                 A6 => EI,
                 AZ => VL1N67);
    
    VL1I394_VL1I1: PAFRAG_F
        port map(F1 => I4,
                 F2 => zero,
                 F3 => I6,
                 F4 => I3,
                 F5 => one,
                 F6 => EI,
                 FZ => VL1N69);
    
    VL1I397_VL1I12: PAFRAG_A
        port map(A1 => I2,
                 A2 => zero,
                 A3 => I4,
                 A4 => I1,
                 A5 => I6,
                 A6 => EI,
                 AZ => VL1N71);
    
    VL1I446_VL1I12: PAFRAG_A
        port map(A1 => I0,
                 A2 => EI,
                 A3 => I1,
                 A4 => zero,
                 A5 => I2,
                 A6 => VL1N499,
                 AZ => VL1N450);
    
    VL1I452_VL1I1: PAFRAG_M
        port map(OS => VL1N450,
                 NSI => VL1N451,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => one,
                 E2 => I3,
                 OZ => EOtmp,
                 NZ => VL1I452_NZ);
    
    VL1I453_VL1I1: PAFRAG_F
        port map(F1 => I4,
                 F2 => zero,
                 F3 => I5,
                 F4 => zero,
                 F5 => I6,
                 F6 => zero,
                 FZ => VL1N451);

	EO <= EOtmp;
    
END archttl148;

--
--	TTL180
--

USE WORK.ttlspc_local.ALL;

ENTITY ttl180 IS
	PORT (A,B,C,D,E,F,G,H, ODDI, EVEI: IN BIT;
	      ODD, EVE: OUT BIT);
END ttl180;

ARCHITECTURE archttl180 of ttl180 is

    signal N_1: bit;
    signal N_2: bit;
    signal N_3: bit;
    signal N_4: bit;
    signal N_5: bit;
    signal N_6: bit;
    signal N_7: bit;
    signal N_8: bit;
    signal QL7_N_1: bit;
    signal QL7_N_2: bit;
    signal QL7_QL2_OZ: bit;
    signal QL8_N_1: bit;
    signal QL8_N_2: bit;
    signal QL8_QL1_NZ: bit;
    signal QL9_N_1: bit;
    signal QL9_N_2: bit;
    signal QL9_QL1_NZ: bit;
    signal QL10_N_1: bit;
    signal QL10_N_2: bit;
    signal QL10_QL1_NZ: bit;
    
begin
    
    QL1_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => N_7,
                 A5 => one,
                 A6 => N_8,
                 AZ => ODD);
    
    QL2_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => N_5,
                 A5 => one,
                 A6 => N_6,
                 AZ => EVE);
    
    QL3_QL1_VL1I12: PAFRAG_A
        port map(A1 => ODDI,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => N_4,
                 AZ => N_8);
    
    QL4_QL1_VL1I12: PAFRAG_A
        port map(A1 => EVEI,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => N_4,
                 AZ => N_6);
    
    QL5_QL1_VL1I12: PAFRAG_A
        port map(A1 => N_4,
                 A2 => zero,
                 A3 => ODDI,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => N_5);
    
    QL6_QL1_VL1I12: PAFRAG_A
        port map(A1 => EVEI,
                 A2 => zero,
                 A3 => N_4,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => N_7);
    
    QL7_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL7_N_2);
    
    QL7_QL2_VL1I1: PAFRAG_M
        port map(OS => QL7_N_2,
                 NSI => QL7_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => N_2,
                 E1 => N_2,
                 E2 => zero,
                 OZ => QL7_QL2_OZ,
                 NZ => N_4);
    
    QL7_QL3_VL1I1: PAFRAG_F
        port map(F1 => N_3,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL7_N_1);
    
    QL8_QL1_VL1I1: PAFRAG_M
        port map(OS => QL8_N_2,
                 NSI => QL8_N_1,
                 B1 => F,
                 B2 => zero,
                 C1 => one,
                 C2 => F,
                 D1 => one,
                 D2 => F,
                 E1 => F,
                 E2 => zero,
                 OZ => N_1,
                 NZ => QL8_QL1_NZ);
    
    QL8_QL2_VL1I1: PAFRAG_F
        port map(F1 => E,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL8_N_1);
    
    QL8_QL3_VL1I12: PAFRAG_A
        port map(A1 => D,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL8_N_2);
    
    QL9_QL1_VL1I1: PAFRAG_M
        port map(OS => QL9_N_2,
                 NSI => QL9_N_1,
                 B1 => H,
                 B2 => zero,
                 C1 => one,
                 C2 => H,
                 D1 => one,
                 D2 => H,
                 E1 => H,
                 E2 => zero,
                 OZ => N_2,
                 NZ => QL9_QL1_NZ);
    
    QL9_QL2_VL1I1: PAFRAG_F
        port map(F1 => G,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL9_N_1);
    
    QL9_QL3_VL1I12: PAFRAG_A
        port map(A1 => N_1,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL9_N_2);
    
    QL10_QL1_VL1I1: PAFRAG_M
        port map(OS => QL10_N_2,
                 NSI => QL10_N_1,
                 B1 => C,
                 B2 => zero,
                 C1 => one,
                 C2 => C,
                 D1 => one,
                 D2 => C,
                 E1 => C,
                 E2 => zero,
                 OZ => N_3,
                 NZ => QL10_QL1_NZ);
    
    QL10_QL2_VL1I1: PAFRAG_F
        port map(F1 => B,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL10_N_1);
    
    QL10_QL3_VL1I12: PAFRAG_A
        port map(A1 => A,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL10_N_2);
    

END archttl180;

--
--	TTL261
--

USE WORK.ttlspc_local.ALL;

ENTITY ttl261 is
	PORT (
	      C : IN BIT;
              B0,B1,B2,B3,B4 : IN BIT;
              M0,M1,M2 : IN BIT;
              Q0,Q1,Q2,Q3,Q4: OUT BIT);
END ttl261;

ARCHITECTURE archttl261 of ttl261 is

    signal Q0tmp, Q1tmp, Q2tmp, Q3tmp, Q4tmp : bit;
    signal VL1N112: bit;
    signal VL1N122: bit;
    signal VL1N127: bit;
    signal VL1N132: bit;
    signal VL1N137: bit;
    signal VL1N153: bit;
    signal VL1N156: bit;
    signal VL1N158: bit;
    signal VL1N174: bit;
    signal VL1N205: bit;
    signal VL1N217: bit;
    signal VL1N248: bit;
    signal VL1N254: bit;
    signal VL1N260: bit;
    signal VL1N268: bit;
    signal VL1N282: bit;
    signal VL1N292: bit;
    signal VL1N299: bit;
    signal VL1N301: bit;
    signal VL1N309: bit;
    signal VL1N311: bit;
    signal VL1N38: bit;
    signal VL1N40: bit;
    signal VL1N42: bit;
    signal VL1N44: bit;
    signal VL1N46: bit;
    signal VL1N57: bit;
    signal VL1N58: bit;
    signal VL1N59: bit;
    signal VL1N60: bit;
    signal VL1N61: bit;
    signal VL1N70: bit;
    signal VL1N71: bit;
    signal VL1N72: bit;
    signal VL1N73: bit;
    signal VL1N74: bit;
    signal VL1N83: bit;
    signal VL1N84: bit;
    signal VL1N85: bit;
    signal VL1N86: bit;
    signal VL1N87: bit;
    signal VL1N90: bit;
    signal VL1N91: bit;
    signal VL1N92: bit;
    signal VL1N93: bit;
    signal VL1N94: bit;
    signal VL1I294_N_1: bit;
    signal VL1I294_N_2: bit;
    signal VL1I294_QL2_OZ: bit;
    signal VL1I295_N_1: bit;
    signal VL1I295_N_2: bit;
    signal VL1I295_QL2_OZ: bit;
    signal VL1I296_N_1: bit;
    signal VL1I296_N_2: bit;
    signal VL1I296_QL2_OZ: bit;
    signal VL1I307_N_1: bit;
    signal VL1I307_N_2: bit;
    signal VL1I307_QL2_OZ: bit;
    signal VL1I314_N_1: bit;
    signal VL1I314_N_2: bit;
    signal VL1I314_QL2_OZ: bit;
    signal VL1I51_N_1: bit;
    signal VL1I51_N_2: bit;
    signal VL1I51_QL1_NZ: bit;
    signal VL1I64_N_1: bit;
    signal VL1I64_N_2: bit;
    signal VL1I64_QL1_NZ: bit;
    signal VL1I77_N_1: bit;
    signal VL1I77_N_2: bit;
    signal VL1I77_QL1_NZ: bit;
    
begin

    VL1I106_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => B0,
                 AZ => VL1N153);
    
    VL1I109_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N153,
                 AZ => VL1N112);
    
    VL1I120_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => B1,
                 AZ => VL1N122);
    
    VL1I121_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N122,
                 AZ => VL1N254);
    
    VL1I125_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => B2,
                 AZ => VL1N127);
    
    VL1I126_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N127,
                 AZ => VL1N260);
    
    VL1I130_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => B3,
                 AZ => VL1N132);
    
    VL1I131_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N132,
                 AZ => VL1N248);
    
    VL1I135_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => B4,
                 AZ => VL1N137);
    
    VL1I136_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => VL1N137,
                 AZ => VL1N158);
    
    VL1I138_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N268,
                 A5 => one,
                 A6 => VL1N156,
                 AZ => VL1N217);
    
    VL1I139_QL1_VL1I12: PAFRAG_A
        port map(A1 => M1,
                 A2 => zero,
                 A3 => M0,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N268);
    
    VL1I142_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => M1,
                 A5 => one,
                 A6 => M0,
                 AZ => VL1N156);
    
    VL1I143_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => C,
                 AZ => VL1N174);
    
    VL1I28_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N268,
                 A4 => zero,
                 A5 => VL1N112,
                 A6 => zero,
                 AZ => VL1N38);
    
    VL1I29_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N156,
                 A4 => zero,
                 A5 => VL1N153,
                 A6 => zero,
                 AZ => VL1N40);
    
    VL1I290_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => q4tmp,
                 AZ => VL1N292);
    
    VL1I294_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I294_N_2);
    
    VL1I294_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I294_N_2,
                 NSI => VL1I294_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I294_QL2_OZ,
                 NZ => VL1N299);
    
    VL1I294_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N40,
                 F3 => one,
                 F4 => VL1N38,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I294_N_1);
    
    VL1I295_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I295_N_2);
    
    VL1I295_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I295_N_2,
                 NSI => VL1I295_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I295_QL2_OZ,
                 NZ => VL1N301);
    
    VL1I295_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N46,
                 F3 => one,
                 F4 => VL1N44,
                 F5 => one,
                 F6 => VL1N42,
                 FZ => VL1I295_N_1);
    
    VL1I296_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I296_N_2);
    
    VL1I296_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I296_N_2,
                 NSI => VL1I296_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I296_QL2_OZ,
                 NZ => q0tmp);
    
    VL1I296_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N301,
                 F3 => one,
                 F4 => VL1N299,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I296_N_1);
    
    VL1I30_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N254,
                 A6 => zero,
                 AZ => VL1N42);
    
    VL1I307_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I307_N_2);
    
    VL1I307_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I307_N_2,
                 NSI => VL1I307_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I307_QL2_OZ,
                 NZ => VL1N311);
    
    VL1I307_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N90,
                 F3 => one,
                 F4 => VL1N91,
                 F5 => one,
                 F6 => VL1N92,
                 FZ => VL1I307_N_1);
    
    VL1I308_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N311,
                 A5 => one,
                 A6 => VL1N309,
                 AZ => q4tmp);
    
    VL1I31_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N174,
                 A2 => zero,
                 A3 => q0tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N46);
    
    VL1I314_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I314_N_2);
    
    VL1I314_QL2_VL1I1: PAFRAG_M
        port map(OS => VL1I314_N_2,
                 NSI => VL1I314_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => VL1I314_QL2_OZ,
                 NZ => VL1N309);
    
    VL1I314_QL3_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N93,
                 F3 => one,
                 F4 => VL1N94,
                 F5 => one,
                 F6 => zero,
                 FZ => VL1I314_N_1);
    
    VL1I32_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N122,
                 A6 => zero,
                 AZ => VL1N44);
    
    VL1I5_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N174,
                 A5 => one,
                 A6 => VL1N282,
                 AZ => VL1N205);
    
    VL1I51_QL2_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N61,
                 F3 => one,
                 F4 => VL1N60,
                 F5 => one,
                 F6 => VL1N59,
                 FZ => VL1I51_N_1);
    
    VL1I51_QL3_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => VL1N58,
                 A3 => one,
                 A4 => VL1N57,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I51_N_2);
    
    VL1I51_QL1_VL1I1: PAFRAG_M
        port map(OS => VL1I51_N_2,
                 NSI => VL1I51_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => q1tmp,
                 NZ => VL1I51_QL1_NZ);
    
    VL1I52_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N127,
                 A6 => zero,
                 AZ => VL1N60);
    
    VL1I53_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N174,
                 A2 => zero,
                 A3 => q1tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N61);
    
    VL1I54_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N260,
                 A6 => zero,
                 AZ => VL1N59);
    
    VL1I55_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N156,
                 A4 => zero,
                 A5 => VL1N122,
                 A6 => zero,
                 AZ => VL1N58);
    
    VL1I56_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N268,
                 A4 => zero,
                 A5 => VL1N254,
                 A6 => zero,
                 AZ => VL1N57);
    
    VL1I6_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => VL1N174,
                 A5 => one,
                 A6 => M2,
                 AZ => VL1N282);
    
    VL1I64_QL2_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N74,
                 F3 => one,
                 F4 => VL1N73,
                 F5 => one,
                 F6 => VL1N72,
                 FZ => VL1I64_N_1);
    
    VL1I64_QL3_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => VL1N71,
                 A3 => one,
                 A4 => VL1N70,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I64_N_2);
    
    VL1I64_QL1_VL1I1: PAFRAG_M
        port map(OS => VL1I64_N_2,
                 NSI => VL1I64_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => q2tmp,
                 NZ => VL1I64_QL1_NZ);
    
    VL1I65_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N132,
                 A6 => zero,
                 AZ => VL1N73);
    
    VL1I66_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N174,
                 A2 => zero,
                 A3 => q2tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N74);
    
    VL1I67_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N248,
                 A6 => zero,
                 AZ => VL1N72);
    
    VL1I68_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N156,
                 A4 => zero,
                 A5 => VL1N127,
                 A6 => zero,
                 AZ => VL1N71);
    
    VL1I69_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N268,
                 A4 => zero,
                 A5 => VL1N260,
                 A6 => zero,
                 AZ => VL1N70);
    
    VL1I77_QL2_VL1I1: PAFRAG_F
        port map(F1 => one,
                 F2 => VL1N87,
                 F3 => one,
                 F4 => VL1N86,
                 F5 => one,
                 F6 => VL1N85,
                 FZ => VL1I77_N_1);
    
    VL1I77_QL3_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => VL1N84,
                 A3 => one,
                 A4 => VL1N83,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1I77_N_2);
    
    VL1I77_QL1_VL1I1: PAFRAG_M
        port map(OS => VL1I77_N_2,
                 NSI => VL1I77_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => zero,
                 E1 => zero,
                 E2 => one,
                 OZ => q3tmp,
                 NZ => VL1I77_QL1_NZ);
    
    VL1I78_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N137,
                 A6 => zero,
                 AZ => VL1N86);
    
    VL1I79_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N174,
                 A2 => zero,
                 A3 => q3tmp,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N87);
    
    VL1I80_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N158,
                 A6 => zero,
                 AZ => VL1N85);
    
    VL1I81_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N156,
                 A4 => zero,
                 A5 => VL1N132,
                 A6 => zero,
                 AZ => VL1N84);
    
    VL1I82_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N268,
                 A4 => zero,
                 A5 => VL1N248,
                 A6 => zero,
                 AZ => VL1N83);
    
    VL1I95_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N268,
                 A4 => zero,
                 A5 => VL1N158,
                 A6 => zero,
                 AZ => VL1N94);
    
    VL1I96_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N156,
                 A4 => zero,
                 A5 => VL1N137,
                 A6 => zero,
                 AZ => VL1N93);
    
    VL1I97_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N282,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N158,
                 A6 => zero,
                 AZ => VL1N92);
    
    VL1I98_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N174,
                 A2 => zero,
                 A3 => VL1N292,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => VL1N90);
    
    VL1I99_QL1_VL1I12: PAFRAG_A
        port map(A1 => VL1N205,
                 A2 => zero,
                 A3 => VL1N217,
                 A4 => zero,
                 A5 => VL1N137,
                 A6 => zero,
                 AZ => VL1N91);

    q0 <= q0tmp;
    q1 <= q1tmp;
    q2 <= q2tmp;
    q3 <= q3tmp;
    q4 <= q4tmp;

END archttl261;

--
--	TTL518
--

USE WORK.ttlspc_local.ALL;

ENTITY ttl518 IS
PORT (G, Q0, Q1, Q2, Q3, Q4, Q5, Q6, Q7,
	 P0, P1, P2, P3, P4, P5, P6, P7 : IN BIT;
      PQ : OUT BIT);
END ttl518;

ARCHITECTURE archttl518 of ttl518 is

    signal N_1: bit;
    signal N_2: bit;
    signal N_3: bit;
    signal N_4: bit;
    signal N_5: bit;
    signal N_6: bit;
    signal N_7: bit;
    signal N_8: bit;
    signal QL1_N_1: bit;
    signal QL1_N_2: bit;
    signal QL1_QL2_OZ: bit;
    signal QL2_N_1: bit;
    signal QL2_N_2: bit;
    signal QL2_QL2_OZ: bit;
    signal QL3_N_1: bit;
    signal QL3_N_2: bit;
    signal QL3_QL2_OZ: bit;
    signal QL4_N_1: bit;
    signal QL4_N_2: bit;
    signal QL4_QL2_OZ: bit;
    signal QL5_N_1: bit;
    signal QL5_N_2: bit;
    signal QL5_QL2_OZ: bit;
    signal QL6_N_1: bit;
    signal QL6_N_2: bit;
    signal QL6_QL2_OZ: bit;
    signal QL7_N_1: bit;
    signal QL7_N_2: bit;
    signal QL7_QL2_OZ: bit;
    signal QL8_N_1: bit;
    signal QL8_N_2: bit;
    signal QL8_QL1_NZ: bit;
    signal QL9_N_1: bit;
    signal QL9_N_2: bit;
    signal QL9_QL2_OZ: bit;
    
begin
    
    QL1_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL1_N_2);
    
    QL1_QL2_VL1I1: PAFRAG_M
        port map(OS => QL1_N_2,
                 NSI => QL1_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P7,
                 E1 => P7,
                 E2 => zero,
                 OZ => QL1_QL2_OZ,
                 NZ => N_8);
    
    QL1_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q7,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL1_N_1);
    
    QL2_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL2_N_2);
    
    QL2_QL2_VL1I1: PAFRAG_M
        port map(OS => QL2_N_2,
                 NSI => QL2_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P6,
                 E1 => P6,
                 E2 => zero,
                 OZ => QL2_QL2_OZ,
                 NZ => N_7);
    
    QL2_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q6,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL2_N_1);
    
    QL3_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL3_N_2);
    
    QL3_QL2_VL1I1: PAFRAG_M
        port map(OS => QL3_N_2,
                 NSI => QL3_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P5,
                 E1 => P5,
                 E2 => zero,
                 OZ => QL3_QL2_OZ,
                 NZ => N_6);
    
    QL3_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q5,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL3_N_1);
    
    QL4_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL4_N_2);
    
    QL4_QL2_VL1I1: PAFRAG_M
        port map(OS => QL4_N_2,
                 NSI => QL4_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P4,
                 E1 => P4,
                 E2 => zero,
                 OZ => QL4_QL2_OZ,
                 NZ => N_5);
    
    QL4_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q4,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL4_N_1);
    
    QL5_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL5_N_2);
    
    QL5_QL2_VL1I1: PAFRAG_M
        port map(OS => QL5_N_2,
                 NSI => QL5_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P3,
                 E1 => P3,
                 E2 => zero,
                 OZ => QL5_QL2_OZ,
                 NZ => N_4);
    
    QL5_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q3,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL5_N_1);
    
    QL6_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL6_N_2);
    
    QL6_QL2_VL1I1: PAFRAG_M
        port map(OS => QL6_N_2,
                 NSI => QL6_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P2,
                 E1 => P2,
                 E2 => zero,
                 OZ => QL6_QL2_OZ,
                 NZ => N_3);
    
    QL6_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q2,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL6_N_1);
    
    QL7_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL7_N_2);
    
    QL7_QL2_VL1I1: PAFRAG_M
        port map(OS => QL7_N_2,
                 NSI => QL7_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => one,
                 D2 => P1,
                 E1 => P1,
                 E2 => zero,
                 OZ => QL7_QL2_OZ,
                 NZ => N_2);
    
    QL7_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q1,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL7_N_1);
    
    QL8_QL1_VL1I1: PAFRAG_M
        port map(OS => QL8_N_2,
                 NSI => QL8_N_1,
                 B1 => zero,
                 B2 => one,
                 C1 => zero,
                 C2 => one,
                 D1 => zero,
                 D2 => one,
                 E1 => N_5,
                 E2 => zero,
                 OZ => PQ,
                 NZ => QL8_QL1_NZ);
    
    QL8_QL2_VL1I1: PAFRAG_F
        port map(F1 => N_4,
                 F2 => zero,
                 F3 => N_3,
                 F4 => zero,
                 F5 => N_2,
                 F6 => zero,
                 FZ => QL8_N_1);
    
    QL8_QL3_VL1I12: PAFRAG_A
        port map(A1 => N_8,
                 A2 => N_1,
                 A3 => N_7,
                 A4 => G,
                 A5 => N_6,
                 A6 => zero,
                 AZ => QL8_N_2);
    
    QL9_QL1_VL1I12: PAFRAG_A
        port map(A1 => one,
                 A2 => zero,
                 A3 => one,
                 A4 => zero,
                 A5 => one,
                 A6 => zero,
                 AZ => QL9_N_2);
    
    QL9_QL2_VL1I1: PAFRAG_M
        port map(OS => QL9_N_2,
                 NSI => QL9_N_1,
                 B1 => one,
                 B2 => zero,
                 C1 => one,
                 C2 => zero,
                 D1 => P0,
                 D2 => zero,
                 E1 => one,
                 E2 => P0,
                 OZ => QL9_QL2_OZ,
                 NZ => N_1);
    
    QL9_QL3_VL1I1: PAFRAG_F
        port map(F1 => Q0,
                 F2 => zero,
                 F3 => one,
                 F4 => zero,
                 F5 => one,
                 F6 => zero,
                 FZ => QL9_N_1);
    
END archttl518;

