--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

use work.c37xp.all;

ENTITY c37xm IS
    GENERIC (
	bsel	: 	polarity := ninv;
	tCLK	:	time :=  4000 ps;
	tIRD	:	time :=  1000 ps;
	tICOMB	:	time :=  3000 ps;
	tILAT	:	time :=  5500 ps;
	tIRSU	:	time :=  6000 ps;
	tIRH	:	time :=  2000 ps;
	tSOP	:	time :=  1500 ps;
	tORD	:	time :=  1000 ps;
	tOCOMB	:	time :=  3000 ps;
	tOLAT	:	time :=  5500 ps;
	tORSU	:	time :=  4500 ps;
	tORH	:	time :=  0000 ps;
	tOD	:	time :=  1000 ps;
	tXZ	:	time :=  8500 ps;
	tZX	:	time :=  8500 ps;
	tFB	:	time :=  0000 ps;
	tRST	:	time :=  8500 ps;
	tPST	:	time :=  8500 ps;
	tWL	:	time :=  2500 ps;
	tWH	:	time :=  2500 ps;
	tRW	:	time :=  8000 ps;
	tRR	:	time := 10000 ps;
	tPW	:	time :=  8000 ps;
	tPR	:	time := 10000 ps);
    PORT (
	x	: in	vlbit;
	oe	: in	vlbit;
	y	: inout	vlbit;
	fb	: out	vlbit);
END c37xm;

ARCHITECTURE sim OF c37xm IS

BEGIN

    -- Simulate the I/O Macro-cell.
    PROCESS (oe, x)

    BEGIN
	IF (bsel = invt) THEN
	    IF (pchanging(oe)) THEN
		IF (oe = '1') THEN
		    y <= NOT x AFTER Tzx;
		ELSE
		    y <= 'Z' AFTER Txz;
		END IF;
	    ELSE
		IF (oe = '1') THEN
		    y <= NOT x  AFTER Tod;
		ELSE
		    y <= 'Z';
		END IF;
	    END IF;
	ELSIF (bsel = ninv) THEN
	    IF (pchanging(oe)) THEN
		IF (oe = '1') THEN
		    y <= x AFTER Tzx;
		ELSE
		    y <= 'Z' AFTER Txz;
		END IF;
	    ELSE
		IF (oe = '1') THEN
		    y <= x AFTER Tod;
		ELSE
		    y <= 'Z';
		END IF;
	    END IF;
	END IF;
    END PROCESS;

    -- Simulate the feedback.
    PROCESS (y)

    BEGIN

	fb <= y AFTER Ticomb;

    END PROCESS;
END sim;
