--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

library ieee;
use ieee.std_logic_1164.all;

PACKAGE c22vp10p IS			-- C22VP10CG Specific package.
    
    TYPE reg_def  IS (reg, comb, dblreg);		-- Noreg generic.
    TYPE polarity IS (invt, ninv);	-- Port polarity.
    TYPE fb_type  IS (xpin, xreg, adj);	-- feedback type.

    COMPONENT c22vp10m			-- Device C22VP10CG macro cell.
	GENERIC (
	    registered	: reg_def	:= reg;	-- Default is REGistered.
	    inv_setting	: polarity	:= invt; -- Default is INVerTed.
	    bta_sel	: fb_type	:= xreg; -- Default is Registered.
	    Tpd		: TIME		:= 5500 ps; -- PALC22VP10CG-5 (PDIP)
	    Tea		: TIME		:= 6 ns;
	    Ter		: TIME		:= 5 ns;
	    Tco		: TIME		:= 4500 ps;
	    Ts		: TIME		:= 2500 ps;
	    Th		: TIME		:= 0 ns;
	    Twh		: TIME		:= 3 ns;
	    Twl		: TIME		:= 3 ns;
	    Tcf		: TIME		:= 3500 ps;
	    Taw		: TIME		:= 6 ns;
	    Tar		: TIME		:= 4 ns;
	    Tap		: TIME		:= 7 ns;
	    Tspr	: TIME		:= 4 ns);
	PORT (
	    d	: IN	std_logic;	-- D input to register.
	    clk	: IN	std_logic;	-- Positive Edge Clock.
	    oe	: IN	std_logic;	-- Output Enable.
	    ss	: IN	std_logic;	-- Synchronous Set (chip wide).
	    ar	: IN	std_logic;	-- Asynchronous Reset (chip wide).
	    y	: INOUT	std_logic;	-- IO pin.
	    fb	: OUT	std_logic);	-- bit To Array (is output from macro cell).
    END COMPONENT;		-- End component c22vp10m.
	
END c22vp10p;			-- End package c22vp10p;

