--
--	Copyright Cypress Semiconductor Corporation, 1994,1995,1996
--	  as an unpublished work.
--

library ieee;
use ieee.std_logic_1164.all;

PACKAGE c331p IS			-- C331 Specific package.

    COMPONENT c331ckmx
	GENERIC (
	    Tpd		: TIME		:= 20 ns;	--cy7c331-20
	    Tico	: TIME		:= 35 ns;
	    Tioh	: TIME		:=  5 ns;
	    Tis		: TIME		:=  2 ns;
	    Tih		: TIME		:= 11 ns;
	    Tiar	: TIME		:= 35 ns;
	    Tirw	: TIME		:= 35 ns;
	    Tirr	: TIME		:= 35 ns;
	    Tias	: TIME		:= 35 ns;
	    Tisw	: TIME		:= 35 ns;
	    Tisr	: TIME		:= 35 ns;
	    Twh		: TIME		:= 12 ns;
	    Twl		: TIME		:= 12 ns;
	    Tco		: TIME		:= 20 ns;
	    Ts		: TIME		:= 12 ns;
	    Th		: TIME		:=  8 ns;
	    Toar	: TIME		:= 20 ns;
	    Torw	: TIME		:= 20 ns;
	    Torr	: TIME		:= 20 ns;
	    Toas	: TIME		:= 20 ns;
	    Tosw	: TIME		:= 20 ns;
	    Tosr	: TIME		:= 20 ns;
	    Tpzx	: TIME		:= 20 ns;
	    Tpxz	: TIME		:= 20 ns);
	PORT (
	    clksrc	:IN	std_logic;
	    clk		:OUT	std_logic);
    END COMPONENT;

    COMPONENT c331m
	GENERIC (
	    Tpd		: TIME		:= 20 ns;	--cy7c331-20
	    Tico	: TIME		:= 35 ns;
	    Tioh	: TIME		:=  5 ns;
	    Tis		: TIME		:=  2 ns;
	    Tih		: TIME		:= 11 ns;
	    Tiar	: TIME		:= 35 ns;
	    Tirw	: TIME		:= 35 ns;
	    Tirr	: TIME		:= 35 ns;
	    Tias	: TIME		:= 35 ns;
	    Tisw	: TIME		:= 35 ns;
	    Tisr	: TIME		:= 35 ns;
	    Twh		: TIME		:= 12 ns;
	    Twl		: TIME		:= 12 ns;
	    Tco		: TIME		:= 20 ns;
	    Ts		: TIME		:= 12 ns;
	    Th		: TIME		:=  8 ns;
	    Toar	: TIME		:= 20 ns;
	    Torw	: TIME		:= 20 ns;
	    Torr	: TIME		:= 20 ns;
	    Toas	: TIME		:= 20 ns;
	    Tosw	: TIME		:= 20 ns;
	    Tosr	: TIME		:= 20 ns;
	    Tpzx	: TIME		:= 20 ns;
	    Tpxz	: TIME		:= 20 ns);
	PORT (
	    x1	 :IN	std_logic;	-- D input to register.
	    x2	 :IN	std_logic;	-- D input to register.
	    clk	 :IN	std_logic;	-- Positive edge clock.
	    iclk :IN	std_logic;	-- Positive edge clock.
	    oe	 :IN	std_logic;	-- output enable
	    as	 :IN	std_logic;	-- Asynchronous Set (chip wide).
	    ar	 :IN	std_logic;	-- Asynchronous Reset (chip wide).
	    ias	 :IN	std_logic;
	    iar	 :IN	std_logic;
	    qfb	 :OUT	std_logic;		-- Bit to Array.
	    y	 :INOUT	std_logic;		-- IO pin
	    qifb :OUT	std_logic);		-- Shared Bit to array
    END COMPONENT;			-- End component c331m.

END c331p;				-- End package c331p;

